#    VRSerror script
#    invoked via the exception monitor call-back mechanism when the 
#    VRS (Neutron Wall) crate halts with a serious error.

#    the variable "resource" contains the name of one the VRS server names!
#    further information may be in the list "parameters"

set host [first $parameters]
set type [second $parameters]


set msg0 " The Neutron Wall crate $host has been rebooted.\n\
           The Data Acquisition system should be STOPPED.\n\
           Do you wish to execute the restart sequence for this crate?"

set msg0 " The Neutron Wall crate $host has been rebooted.\n\
           The Data Acquisition system should be STOPPED.\n\
           You must reload the VME configuration and then setup the Neutron Wall register values."

set msg1 " Do you wish to software reset the Neutron Wall crate?"

set msg2 " Do you wish to restore the Neutron Wall crate parameters?"

if {$type == "reboot"} then {
   midas-report $msg0
   inform vmecontrol "start"
   inform nwall "start"


#  if {[midas-confirmation "$msg0"] == 0} then {return "Action sequence aborted"}

#  if {[midas-confirmation "$msg1"] == 0} then {return "Action sequence aborted"}
#  inform vmecontrol "start"
#  inform vmecontrol "DAQ-reset"

#  if {[midas-confirmation "$msg2"] == 0} then {return "Action sequence aborted"}
#  inform vmesaverestore SSRstart

#  midas-report "When the window \"Saving and Restoring VME Module Setups\" starts check that the \"Directory\" is correct (or select the required save).\n Then click on \"Restore\".\n When this has completed the VRSrestart action is complete"

  return "Action Completed"

}

set msg3 " The Neutron Wall crate $host has halted.\n\
           The Data Acquisition system should be STOPPED and RESET.\n\
           You may then make the Data Acquisition system GO again.\n"

set msg4 " The Neutron Wall crate $host has halted.\n\
           This is due to a serious event sequencing error that cannot be automatically corrected.\n\
           The Data Acquisition system should be STOPPED.\n\
           You may then make the Data Acquisition system GO again.\n"

set msg $msg3
if {$type == "error"} then {set msg $msg4}

#midas-report $msg

insert-log $msg

#inform sys do_stop&go

return "Action Completed"
  
