# beSetup-hi.tcl---Back End Setup Histogrammer frame

loadsource common.lnl
loadsource common.lsf
loadsource common.orbix
loadsource common.$mytaskfirstname

set icontitle 	  "hiSetup"

set frame_name_hs  [self frame-name].hs_mod
set frame_name_hm  [self frame-name].hm_mod
set frame_name_brg [self frame-name].brg_mod

#-------------- Servers Variables -----------------------
set label_hs "Histogrammer Servers"

set histoS_line_select 	{}
set histoS_list 	{}
set histoS_conf 	""
set histoS_cf 	        ""
set histoS_file 	""

set open_frame_mod_hs 0
set install_needed_hs 0

set host_hs	""
set port 	""
set port_hold   ""
set server_hs 	""
set server_hold_hs "" 
set dir_hs 	   ""
set bin_hs      ""

set servers_hold_list_hs {}
set hosts_hold_list_hs   {}
set ports_allocate_list  {}
set ports_available_list {}
set servers_persistent_list_hs {}
set servers_allocate_list_hs {}
set servers_available_list_hs  {}

#-------------- Manager Variables -----------------------
set label_hm "Histogrammer Manager"

set histoM_line_select  {}
set histoM_list         {}
set histoM_conf 	""
set histoM_cf           ""
set histoM_file 	""

set open_frame_mod_hm 0
set install_needed_hm 0

set server_hm     	""
set server_hold_hm      ""
set host_hm 	        ""
set host_hold_hm   	""
set dir_hm 	        ""
set bin_hm 		""

set servers_persistent_list_hm {}
set servers_allocate_list_hm   {}
set servers_available_list_hm  {}

#-------------- Bridge Variables -----------------------
set label_brg "Histogrammer Bridge"

set histoB_line_select  {}
set histoB_list         {}
set histoB_conf 	""

set open_frame_mod_brg 0
set install_needed_brg 0

set server_brg 	     ""
set server_hold_brg  ""
set host_brg 	     ""
set host_hold_brg    ""
set bin_brg  	     ""

set servers_persistent_list_brg {}
set servers_allocate_list_brg   {}
set servers_available_list_brg  {}

#####################  FRAMES  #############################

proc make-frame {} {
   global env edit
   global line_index histoS_conf histoM_conf histoB_conf

   if {$edit} then {
      set option_list F; set option_foot T; set inactive F
   }  else {
      set option_list T; set option_foot F; set inactive T
      set line_index -1
   }

   :frame [self frame-name] :label [self frame-title] :show-footer $option_foot \
      :icon-image "@$env(ICONHOME)/euroball" \
      :icon-name [self icon-title] :resize F

      :panel BEGIN :layout T
        :layout H
          :button QUIT :padx 45

      :panel HS_TITLE :layout T :padx 10 :pady 10 
   	 :layout H
         :message HS_TTL_1 :label "Servers Configuration File :"
         :message HS_TTL_2 :label "$histoS_conf"

      :panel HS_DATA :layout T :padx 10 :pady 0 
   	 :layout V
	 :message HS_MESS :bold F :label \
			"Host Name\tServer Name\t\t Port Number\
			 \tHisto Directory\t\t\tLogger File"
         :list HS_LIST :rows 5 :cols 88 :exclusive T :deaf $option_list

      :panel HS_ACTIONS :layout T :padx 10 :pady 5
   	 :layout H
	 :button HS_ADD    :label "Add..."    :padx 18 :inactive $inactive
	 :button HS_MODIFY :label "Modify..." :padx 10 :inactive $inactive
	 :button HS_DELETE :label "Delete..." :padx 10 :inactive $inactive

      :panel HM_TITLE :layout T :padx 10 :pady 0 
    	 :layout H
         :message HM_TTL_1 :label "Manager Configuration File :"
         :message HM_TTL_2 :label "$histoM_conf"

      :panel HM_DATA :layout T :padx 10 :pady 0 
   	 :layout V
	 :message HM_MESS :bold F :label \
			" Host Name\tManager Name\
			 \t\tConfiguration File\tLogger File  \
			 \tHisto Directory"
         :list HM_LIST :rows 1 :cols 88 :exclusive T :deaf $option_list

      :panel HM_ACTIONS :layout T :padx 10 :pady 5 
   	 :layout H
	 :button HM_MODIFY :label "Modify..." :padx 10 :inactive $inactive
 
      :panel BRG_TITLE :layout T :padx 10 :pady 0 
    	 :layout H
         :message BRG_TTL_1 :label "Bridge Configuration File :" 
         :message BRG_TTL_2 :label "$histoB_conf"

      :panel BRG_DATA :layout T :padx 10 :pady 0 
   	 :layout V
	 :message BRG_MESS :bold F :label \
			" Host Name\tBridge Name \t\tManager File"
         :list BRG_LIST :rows 1 :cols 50 :exclusive T :deaf $option_list

      :panel BRG_ACTIONS :layout T :padx 10 :pady 5 
   	:layout H
        :button BRG_MODIFY :label "Modify..." :padx 10 :inactive $inactive
      
   :show T
}


proc make-frame-modify-hs {} {
   global host_hs  server_hs  port  dir_hs frame_name_hs label_hs env
   global fhosts_list servers_available_list_hs ports_available_list
   global modify add open_frame_mod_hs histoS_line_select

   set title ""
   set label ""

   if {$modify} then {
      set title "$label_hs : Modify"
      set label "Apply"
      click-list-hs $histoS_line_select
      select-line-histoS
   }

   if {$add} then {
      set title "$label_hs : Addition"
      set label "Add"
      set host_hs ""
      set server_hs ""
      set port ""
      deselect-line-histoS
   }

   :frame $frame_name_hs :label $title :show-footer T \
        :icon-image "@$env(ICONHOME)/euroball" \
	:icon-name [self icon-title] :resize F

        :panel HS_MOD_PARAM :layout T :padx 20 :pady 20 
     	   :layout H; :row-gap 5
   	   :choice-stack HS_HOST :label Host :strings $fhosts_list :value [lsearch $fhosts_list $host_hs]
           :next-row T
  	   :menubutton HS_SERVERMENU :label Server :menu $servers_available_list_hs
 	   :text HS_SERVER :label "" :w 20  :value $server_hs :deaf T
           :next-row T
   	   :menubutton HS_PORTMENU :label Port :menu $ports_available_list
  	   :text HS_PORT :label "" :w 6 :value $port :deaf T
           :next-row T
  	   :text HS_DIR :label Directory :w 35  :shifters T :value $dir_hs

        :panel-dialog 40 CANCEL "click-mod-cancel-hs"  $label "click-mod-add-hs" 

   :show T

   set open_frame_mod_hs 1
}


proc make-frame-modify-hm {} {
   global  host_hm  server_hm open_frame_mod_hm dir_hm
   global  hosts_list servers_available_list_hm
   global  frame_name_hm label_hm env histoM_line_select

   click-list-hm $histoM_line_select
   select-line-histoM

   :frame $frame_name_hm :label "$label_hm : Modify" \
	:show-footer T \
	:icon-image "@$env(ICONHOME)/euroball" \
	:icon-name [self icon-title] :resize F
	
        :panel HM_MOD_PARAM :layout T :padx 20 :pady 20 
     	   :layout H; :row-gap 5
   	   :choice-stack HM_HOST :label Host :strings $hosts_list :value [lsearch $hosts_list $host_hm]
           :next-row T
  	   :menubutton HM_SERVERMENU :label Manager :menu $servers_available_list_hm
 	   :text HM_SERVER :label "" :w 20 :value $server_hm
           :next-row T
  	   :text HM_DIR :label Directory :w 35 :shifters T :value $dir_hm

       :panel-dialog 40 CANCEL "click-mod-cancel-hm"  APPLY  "click-mod-add-hm" 
        	       
   :show T

   set open_frame_mod_hm 1
}

proc make-frame-modify-brg {} {
   global  host_brg  server_brg open_frame_mod_brg
   global  hosts_list servers_available_list_brg
   global  frame_name_brg label_brg env histoB_line_select

   click-list-brg $histoB_line_select
   select-line-histoB

   :frame $frame_name_brg :label "$label_brg : Modify" \
	:show-footer T \
	:icon-image "@$env(ICONHOME)/euroball" \
	:icon-name [self icon-title] :resize F
	
        :panel BRG_MOD_PARAM :layout T :padx 20 :pady 20 
     	   :layout H; :row-gap 5
   	   :choice-stack BRG_HOST :label Host :strings $hosts_list :value [lsearch $hosts_list $host_brg]
           :next-row T
  	   :menubutton BRG_SERVERMENU :label Bridge :menu $servers_available_list_brg
 	   :text BRG_SERVER :label "" :w 20 :value $server_brg

       :panel-dialog 40 CANCEL "click-mod-cancel-brg"  APPLY  "click-mod-add-brg" 
        	       
   :show T

   set open_frame_mod_brg 1
}


#####################  PROC  #############################

#-------------------------  parameters ---------------------------------

proc init-parameters {} {
    global dir_hs dir_hm bin_hs bin_hm bin_brg log_file histoS_file 
    global histoS_conf histoM_conf histoS_cf histoM_cf histoM_file
    global histoB_conf env edit frametitle

    if {$edit} then {
       set frametitle "Histogrammer Configuration Tool (Edit)"
    } else {
       set frametitle "Histogrammer Configuration Tool (Display)"
    }
    
    set dir_hs       "$env(EB_HISTOBASE)"
    set dir_hm 	     "$env(EB_HISTOBASE)"
 
    set bin_hs	     "$env(EB_BIN)/EB_HistoServer"
    set bin_hm	     "$env(EB_BIN)/EB_HistoManager"
    set bin_brg	     "$env(EB_BIN)/EB_HistoBridge"

    set log_file     "log.cf"
    set histoS_file  "histoS.cf"
    set histoM_file  "histoM.cf"
    set histoS_conf  "$env(EB_ETC)/histoS.conf"
    set histoM_conf  "$env(EB_ETC)/histoM.conf"
    set histoB_conf  "$env(EB_ETC)/histoB.conf"
    set histoS_cf    "$env(EB_CONFIG)/histoS.cf"
    set histoM_cf    "$env(EB_CONFIG)/histoM.cf"

    init-ports-hs
    init-servers-hs
    init-servers-hm
    init-servers-brg
}


proc init-ports-hs {} {
    global ports_available_list ports_list_hi

    set ports_available_list  $ports_list_hi
}

proc init-servers-hs {} {
    global servers_available_list_hs servers_allocate_list_hs
    global servers_hold_list_hs
    global servers_persistent_list_hs 

    set servers_persistent_list_hs {
	HistogramServer0 HistogramServer1 HistogramServer2 \
 	HistogramServer3 HistogramServer4 HistogramServer5 \
	HistogramServer6 HistogramServer7}
    set servers_available_list_hs $servers_persistent_list_hs
    set servers_allocate_list_hs {}
    set servers_hold_list_hs {}
}

proc init-servers-hm {} {
    global servers_available_list_hm servers_allocate_list_hm
    global servers_persistent_list_hm

    set servers_persistent_list_hm {HistogramManager}
    set servers_available_list_hm  $servers_persistent_list_hm
    set servers_allocate_list_hm {}
}

proc init-servers-brg {} {
    global servers_available_list_brg servers_allocate_list_brg
    global servers_persistent_list_brg

    set servers_persistent_list_brg {HistogramBridge}
    set servers_available_list_brg  $servers_persistent_list_brg
    set servers_allocate_list_brg {}
}
    
proc display-hs {} {
    global host_hs server_hs port dir_hs fhosts_list

    :modify HS_HOST   :value [lsearch $fhosts_list $host_hs]
    :modify HS_SERVER :value $server_hs
    :modify HS_PORT   :value $port
    :modify HS_DIR    :value $dir_hs
}

proc display-hm {} {
    global   host_hm server_hm dir_hm hosts_list

    :modify HM_HOST   :value [lsearch $hosts_list $host_hm]
    :modify HM_SERVER :value $server_hm
    :modify HM_DIR    :value $dir_hm
}

proc display-brg {} {
    global   host_brg server_brg hosts_list

    :modify HM_HOST   :value [lsearch $hosts_list $host_brg]
    :modify HM_SERVER :value $server_brg
}

#-------------------------  servers ------------------------------------

proc write-histoS_conf {fn} {
    global  histoS_list

    set header { {# Configuration file for Histo Servers}
 	      {# each line contains the definition of an histo server}
	      {# and has the following fields}
	      {#}
{# host		servername	      port	     histo-dir	   	  log-config}
	      {#} }

    set data [concat $header $histoS_list]
    write-file $fn $data
    distribution $fn
}

proc write-histoS_cf {fn} {
    global  dir_hs histoS_list

    set data {}
    lappend data "$dir_hs"
    foreach r $histoS_list {
	set active_servers [lsit [first $r]]
	foreach s $active_servers {
	    if {[second $r] == $s} {
		lappend data "[first $r]\t :[second $r]\t [fourth $r]"
            }
	}
    }
    write-file $fn $data
    distribution $fn
}

proc display-histoS_conf {data} {
   global histoS_list line_index edit
   set histoS_list {}

   foreach r $data {lappend histoS_list [get-line-histoS $r]}
   if {[llength $histoS_list] != 0 } {
      set line_index 0
      select-line-histoS
      if {!$edit} {deselect-line-histoS}
   } 
}

proc get-line-histoS {ps} {
   global servers_allocate_list_hs ports_allocate_list
   global servers_available_list_hs ports_available_list
   global servers_hold_list_hs hosts_hold_list_hs

   set host   [first $ps]
   set server [second $ps]
   set port   [third $ps]
   set dir    [fourth $ps]
   set log_f  [fifth $ps]

   lappend servers_allocate_list_hs $server
   lappend ports_allocate_list      $port

   lappend servers_hold_list_hs	    $server
   lappend hosts_hold_list_hs	    $host

   set servers_available_list_hs [\
		      ldelete $servers_available_list_hs $server]
   set ports_available_list [ldelete $ports_available_list $port]

   return [format-line-histoS $host $server $port $dir $log_f]
}


proc format-line-histoS {h s p d f} {

   format " %-12s %-23s %-9d %-28s %s" $h $s $p $d $f
}


proc select-line-histoS {} {
   global line_index histoS_list histoS_line_select

   :modify HS_LIST :empty T :append T :strings $histoS_list :select $line_index

   set histoS_line_select [lindex $histoS_list $line_index]
}

proc deselect-line-histoS {} {
   global line_index histoS_list

   :modify HS_LIST :empty T :append T :strings $histoS_list :deselect $line_index
}

proc modify-histoS {} {
   global histoS_line_select line_index histoS_list
   global host_hs dir_hs log_file
   global server_hs server_hold_hs
   global port port_hold
   global ports_allocate_list ports_available_list
   global servers_allocate_list_hs servers_available_list_hs

   set r [format-line-histoS $host_hs $server_hs $port $dir_hs $log_file]

   if {$line_index != -1} {
      if {[llength $histoS_list] >= 0} {
         set ll [lreplace $histoS_list $line_index $line_index $r]
         set histoS_list $ll
         select-line-histoS

         set i [lsearch -exact $servers_allocate_list_hs $server_hold_hs]
    	 if {$i >= 0} then {
	    set servers_allocate_list_hs [\
		lreplace $servers_allocate_list_hs $i $i $server_hs]
	 }
         set i [lsearch -exact $servers_available_list_hs $server_hs]
    	 if {$i >= 0} then {
	    set servers_available_list_hs [\
		lreplace $servers_available_list_hs $i $i $server_hold_hs]
	 }
         set i [lsearch -exact $ports_allocate_list $port_hold]
    	 if {$i >= 0} then {
	    set ports_allocate_list [\
		lreplace $ports_allocate_list $i $i $port]
	 }
         set i [lsearch -exact $ports_available_list $port]
    	 if {$i >= 0} then {
	    set ports_available_list [\
		lreplace $ports_available_list $i $i $port_hold]
	 }
      }
   }
}

proc add-histoS {} {
   global  host_hs server_hs port dir_hs log_file
   global  line_index histoS_list
   global  servers_allocate_list_hs ports_allocate_list
   global  servers_available_list_hs ports_available_list

   set r [format-line-histoS $host_hs $server_hs $port $dir_hs $log_file]
   lappend histoS_list [get-line-histoS $r]
   set line_index [expr [llength $histoS_list] - 1]
   select-line-histoS

   set ports_available_list [ldelete $ports_available_list $port]
   lappend ports_allocate_list  $port

   set servers_available_list_hs [ldelete $servers_available_list_hs  $server_hs]
   lappend servers_allocate_list_hs  $server_hs
}


#-------------------------  manager ------------------------------------

proc write-histoM_conf {fn} {
    global  histoM_list

    set header { {# Configuration file for Histo Manager}
	      {#}
{# host		managername	     HS-config	      log-config    Histo Directory}
	      {#} }

    set data [concat $header $histoM_list]
    write-file $fn $data    
    distribution $fn
}

proc write-histoM_cf {fn } {
    global  histoM_list

    foreach r $histoM_list {
	set host   [first  $r]
	set server [second $r]
    }
    set data [list "$host\t :$server"]
    write-file $fn $data
    distribution $fn 
}

proc display-histoM_conf {data} {
   global  histoM_list edit

   set histoM_list {}

   foreach r $data {lappend histoM_list [get-line-histoM $r]}
   if {[llength $histoM_list] >= 0 } {select-line-histoM} 
   if {!$edit} {deselect-line-histoM}
}

proc get-line-histoM {ps} {
   global host_hold_hm server_hold_hm

   set host        [first  $ps]
   set server      [second $ps]
   set histoS_file [third  $ps]
   set log_file    [fourth $ps]
   set dir_hm      [fifth $ps]

   set host_hold_hm   $host
   set server_hold_hm $server

   return [format-line-histoM $host $server $histoS_file $log_file $dir_hm]
}

proc format-line-histoM {h s cf lf d} {

   format " %-12s %-23s %-17s %-12s %s" $h $s $cf $lf $d
}

proc select-line-histoM {} {
   global  histoM_list histoM_line_select

   :modify HM_LIST :empty T :append T :strings $histoM_list :select 0
   set histoM_line_select [lindex $histoM_list 0]
}
   
proc deselect-line-histoM {} {
   global  histoM_list

   :modify HM_LIST :empty T :append T :strings $histoM_list :deselect 0
}

proc modify-histoM {} {
   global histoM_list host_hm server_hm histoS_file log_file dir_hm
   
   set r [format-line-histoM $host_hm $server_hm $histoS_file $log_file $dir_hm]
   set histoM_list [list $r]
   select-line-histoM
}


#-------------------------  bridge ------------------------------------

proc write-histoB_conf {fn} {
    global  histoB_list

    set header { {# Configuration file for Histo Bridge}
	      {#}
              {# host		 bridgename	     manager-config}
	      {#} }

    set data [concat $header $histoB_list]
    write-file $fn $data    
    distribution $fn
}

proc display-histoB_conf {data} {
   global  histoB_list edit

   set histoB_list {}

   foreach r $data {lappend histoB_list [get-line-histoB $r]}
   if {[llength $histoB_list] >= 0 } {select-line-histoB} 
   if {!$edit} {deselect-line-histoB}
}

proc get-line-histoB {ps} {
   global host_hold_brg server_hold_brg

   set host        [first  $ps]
   set server      [second $ps]
   set histoM_file [third  $ps]

   set host_hold_brg   $host
   set server_hold_brg $server

   return [format-line-histoB $host $server $histoM_file]
}

proc format-line-histoB {h s mf} {format " %-12s %-21s %s" $h $s $mf}

proc select-line-histoB {} {
   global  histoB_list histoB_line_select

   :modify BRG_LIST :empty T :append T :strings $histoB_list :select 0
   set histoB_line_select [lindex $histoB_list 0]
}
   
proc deselect-line-histoB {} {
   global  histoB_list

   :modify BRG_LIST :empty T :append T :strings $histoB_list :deselect 0
}

proc modify-histoB {} {
   global histoB_list host_brg server_brg histoM_file
   
   set r [format-line-histoB $host_brg $server_brg $histoM_file]
   set histoB_list [list $r]
   select-line-histoB
}


#####################  CLICK  #############################

proc click {arg} {
   global debug hosts_list fhosts_list

   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]

   if {$c==":quit"} then {click-quit $f; return}

   switch  $w {
      HS_LIST 	      {click-list-hs $v}
      HS_MODIFY       {click-modify-hs}
      HS_ADD 	      {click-add}
      HS_DELETE       {click-delete}
      HS_HOST 	      {click-host-hs [lindex $fhosts_list $v]}
      HS_SERVERMENU   -
      HS_SERVER       {click-server-hs $v}
      HS_PORTMENU     -
      HS_PORT 	      {click-port $v}
      HS_DIR 	      {click-dir-hs $v}

      HM_LIST 	      {click-list-hm $v}
      HM_MODIFY       {click-modify-hm}
      HM_HOST 	      {click-host-hm [lindex $hosts_list $v]}
      HM_SERVERMENU   -
      HM_SERVER       {click-server-hm $v}
      HM_DIR 	      {click-dir-hm $v}

      BRG_LIST 	      {click-list-brg $v}
      BRG_MODIFY      {click-modify-brg}
      BRG_HOST 	      {click-host-brg [lindex $hosts_list $v]}
      BRG_SERVERMENU  -
      BRG_SERVER      {click-server-brg $v}

      QUIT 	      {click-quit $f}

      default 	      {puts stdout $arg}
   }
}

proc click-quit {f} {
    global open_frame_mod_hs open_frame_mod_hm open_frame_mod_brg
    global frame_name_hs frame_name_hm frame_name_brg
    global frame mytaskfirstname

    switch  $f {
      $frame.HS_MOD {set open_frame_mod_hs 0; close-frame $f}
      $frame.HM_MOD {set open_frame_mod_hm 0; close-frame $f}
      $frame.BRG_MOD {set open_frame_mod_brg 0; close-frame $f}
      default {
          if {$open_frame_mod_hs} then {
             set open_frame_mod_hs 0
             close-frame $frame_name_hs
          }
          if {$open_frame_mod_hm} then {
             set open_frame_mod_hm 0
             close-frame $frame_name_hm
          }     
          if {$open_frame_mod_brg} then {
             set open_frame_mod_brg 0
             close-frame $frame_name_brg
          }    
          close-frame $f
       }
    }
    clear-footer
    inform $mytaskfirstname quit-histo [winfo x .] [winfo y .]
    set open_frame_mod_hm 0
    set open_frame_mod_hs 0
    set open_frame_mod_brg 0
}


#---------------- Servers ------------------------------------

proc click-list-hs {e} {
   global host_hs server_hs port dir_hs log_file
   global histoS_line_select line_index histoS_list
   global open_frame_mod_hs add label_hs

   if {$add} {deselect-line-histoS; return}

   set histoS_line_select $e
   set line_index [lsearch -exact $histoS_list $e]

   set line [expr $line_index + 1]
   set-footer "$label_hs: line $line selected..."

   set host_hs     [first $e]
   set server_hs   [second $e]
   set port    	   [third $e]
   set dir_hs      [fourth $e]
#   set log_file    [fifth $e]

   if {$open_frame_mod_hs} {display-hs}
}


proc click-modify-hs {} {
   global  add modify label_hs histoS_list

   if {$histoS_list == {}} {return}
   set modify 1; set add 0
   set-footer "$label_hs: modify..."
   make-frame-modify-hs
}


proc click-add {} {
   global  add modify label_hs

   set-footer "$label_hs: add line..."
   set add 1; set modify 0
   make-frame-modify-hs
}

proc click-delete {} {
   global  histoS_list line_index histoS_line_select
   global  servers_allocate_list_hs ports_allocate_list
   global  servers_available_list_hs ports_available_list
   global  port label_hs frame_name add mytaskfirstname
   global  host_hs server_hs histoS_cf histoS_conf

   if {$histoS_list == {}} {return}
   set add 0

   click-list-hs $histoS_line_select
   set line [expr $line_index + 1]

   set d [midas-confirmation \
       "$label_hs - Delete\n\n\
       This operation will KILL any existing server \n\
       Do you wish to continue?"]

   if {$d} then  {
      set i [lsearch -exact $histoS_list $histoS_line_select]
      if {$i >= 0} {
         set-busy-watch "Killing server \"$server_hs\" : Waiting..."
         set ll [lreplace $histoS_list $i $i]
         set histoS_list $ll
         set line_index 0
         select-line-histoS

   	 set ports_allocate_list [ldelete $ports_allocate_list $port]
  	 lappend ports_available_list  $port

   	 set servers_allocate_list_hs [ldelete $servers_allocate_list_hs $server_hs]
   	 lappend servers_available_list_hs $server_hs

         write-histoS_conf $histoS_conf

         set mes [killit $host_hs $server_hs]; print-messages $mes
         write-histoS_cf $histoS_cf

	 delete-line-list
         inform $mytaskfirstname update-histoS_conf $histoS_list
         clear-busy-watch
         set-footer "$label_hs: delete line $line..."
      }
   }
}

proc click-host-hs {h} {
   global host_hs frame_name_hs install_needed_hs

   clear-footer $frame_name_hs
   set host_hs $h
   set install_needed_hs 1
}

proc click-server-hs {s} {
   global server_hs server_hold_hs 
   global frame_name_hs install_needed_hs

   clear-footer $frame_name_hs
   set server_hold_hs $server_hs
   set server_hs $s
   :modify HS_SERVER :value $server_hs
   set install_needed_hs 1
}

proc click-port {p} {
   global port port_hold 
   global frame_name_hs install_needed_hs

   clear-footer $frame_name_hs
   set port_hold $port
   set port $p
   :modify HS_PORT :value $port
   set install_needed_hs 1
}

proc click-dir-hs {d} {
   global dir_hs  frame_name_hs
   global install_needed_hs

   clear-footer $frame_name_hs
   set dir_hs $d
   :modify HS_DIR :value $dir_hs
   set install_needed_hs 1
}

proc click-mod-add-hs {} {
   global  host_hs server_hs port dir_hs install_needed_hs
   global  modify add open_frame_mod_hs label_hs frame_name_hs
   global  histoS_list mytaskfirstname

   if {$install_needed_hs} then {
      set-footer "$label_hs: install (needed)..."
      set z [expr [llength $host_hs] && [llength $server_hs] && \
	       [llength $port] && [llength $dir_hs] ]
      if {$z == 0} then {
         set-footer $frame_name_hs "Choice parameters in the menu list !!!"
         set-footer "$label_hs: Error !!!"
         display-error "Entry invalid parameter : null value"
         clear-footer
         set open_frame_mod_hs 0
         return
      }
      if {$modify} then {modify-histoS}
      if {$add} then {
        add-histoS
        select-line-histoS
      }
   } else {
       select-line-histoS
   }
 
   insert-line-list

   set add 0
   set modify 0
   set open_frame_mod_hs 0
   inform $mytaskfirstname update-histoS_conf $histoS_list
   close-frame $frame_name_hs
}
 
proc click-mod-cancel-hs {} {
   global  open_frame_mod_hs install_needed_hs frame_name_hs
   global  add modify
   
   set install_needed_hs 0; set open_frame_mod_hs 0
   set add 		 0; set modify 		  0

   select-line-histoS
   close-frame $frame_name_hs
}


#---------------- Manager ------------------------------------

proc click-list-hm {e} {
   global host_hm server_hm  histoS_file log_file
   global histoM_line_select open_frame_mod_hm label_hm

   set-footer "$label_hm: line selected..."

   set histoM_line_select $e
   set host_hm     [first $e]
   set server_hm   [second $e]
#   set histoS_file [third $e]
#   set log_file    [fourth $e]

   if {$open_frame_mod_hm} {display-hm}
}

proc click-modify-hm {} {
   global label_hm

   set-footer "$label_hm: modify..."
   make-frame-modify-hm
}

proc click-host-hm {h} {
   global host_hm frame_name_hm install_needed_hm

   clear-footer $frame_name_hm
   set host_hm $h
   set install_needed_hm 1
}

proc click-server-hm {s} {
   global server_hm frame_name_hm install_needed_hm

   clear-footer $frame_name_hm
   set server_hm $s
   :modify HM_SERVER :value $server_hm
   set install_needed_hm 1
}

proc click-dir-hm {d} {
   global dir_hm label_hm frame_name_hm
   global install_needed_hm

   clear-footer $frame_name_hm
   set dir_hm $d
   :modify HM_DIR :value $dir_hm
   set install_needed_hm 1
}

proc click-mod-add-hm {} {
   global  host_hm server_hm label_hm install_needed_hm
   global  open_frame_mod_hm frame_name_hm
   global  histoM_list mytaskfirstname

   if {$install_needed_hm} then {
      set-footer "$label_hm: install (needed)..."
      set z [expr [llength $host_hm] && [llength $server_hm]]
      if {$z == 0} then {
         set-footer $frame_name_hm "Choice parameters in the menu list !!!"
         set-footer "$label_hm: Error !!!"
         display-error "Entry invalid parameter : null value"
         clear-footer
         set open_frame_mod_hs 0
         return
      }
      modify-histoM
   } else {
     select-line-histoM
   }
   set open_frame_mod_hm 0
   inform $mytaskfirstname update-histoM_conf $histoM_list
   close-frame $frame_name_hm
}
 
proc click-mod-cancel-hm {} {
   global  open_frame_mod_hm install_needed_hm frame_name_hm

   set install_needed_hm 0; set open_frame_mod_hm 0

   close-frame $frame_name_hm
}


#---------------- Bridge ------------------------------------

proc click-list-brg {e} {
   global host_brg server_brg 
   global histoB_line_select open_frame_mod_brg label_brg

   set-footer "$label_brg: line selected..."

   set histoB_line_select $e
   set host_brg     [first $e]
   set server_brg   [second $e]

   if {$open_frame_mod_brg} {display-brg}
}

proc click-modify-brg {} {
   global label_brg

   set-footer "$label_brg: modify..."
   make-frame-modify-brg
}

proc click-host-brg {h} {
   global host_brg frame_name_brg install_needed_brg

   clear-footer $frame_name_brg
   set host_brg $h
   set install_needed_brg 1
}

proc click-server-brg {s} {
   global server_brg frame_name_brg install_needed_brg

   clear-footer $frame_name_brg
   set server_brg $s
   :modify BRG_SERVER :value $server_brg
   set install_needed_brg 1
}

proc click-mod-add-brg {} {
   global  host_brg server_brg label_brg install_needed_brg
   global  open_frame_mod_brg frame_name_brg
   global  histoB_list mytaskfirstname

   if {$install_needed_brg} then {
      set-footer "$label_brg: install (needed)..."
      set z [expr [llength $host_brg] && [llength $server_brg]]
      if {$z == 0} then {
         set-footer $frame_name_brg \
        	    "Choice parameters in the menu list !!!"
         set-footer "$label_brg: Error !!!"
         display-error "Entry invalid parameter : null value"
         clear-footer
         set open_frame_mod_hs 0
         return
      }
      modify-histoB
   } else {
      select-line-histoB
   }
   set open_frame_mod_brg 0
   inform $mytaskfirstname update-histoB_conf $histoB_list
   close-frame $frame_name_brg
}
 
proc click-mod-cancel-brg {} {
   global  open_frame_mod_brg install_needed_brg frame_name_brg

   set install_needed_brg 0; set open_frame_mod_brg 0

   close-frame $frame_name_brg
}


#----------------- proc installation -------------------------------


proc putit-hs {} {
    global histoS_list bin_hs histoS_cf
    global servers_hold_list_hs hosts_hold_list_hs log_file
    set mess_list {}

    if {[llength $histoS_list] == 0} then {return 0}

    for {set i 0} {$i < [llength $histoS_list]} {incr i} {
        set r 	   [lindex $histoS_list $i]
	set host   [first  $r]
	set server [second $r]
	set port   [third  $r]
	set dir    [fourth $r]

        set server_hold [lindex $servers_hold_list_hs $i]
        set host_hold   [lindex $hosts_hold_list_hs   $i]

 	set mes [killit $host_hold $server_hold]
        if {$mes == -1} {return -1} else {print-messages $mes}

        lappend mess_list "Putting $server $port $log_file on machine $host"

	set z [catch {exec putit -h $host $server \
				   "$bin_hs $server $port $log_file"} m]
	if {$z} {
	   set tmp {}; lappend tmp $m; print-messages $tmp; return -1
	} else {
	   lappend mess_list $m
	}
	set z [catch {exec chmodit -h $host $server "i+all"} m]
	if {$z} {
	   set tmp {}; lappend tmp $m; print-messages $tmp; return -1
	} else {
	   lappend mess_list $m
	}
	set z [catch {exec chmodit -h $host $server "l+all"} m]
	if {$z} {
	   set tmp {}; lappend tmp $m; print-messages $tmp; return -1
	} else {
	   lappend mess_list $m
	}

        set ll [lreplace $servers_hold_list_hs $i $i $server]
	set servers_hold_list_hs $ll
        set ll [lreplace $hosts_hold_list_hs $i $i $host]
	set hosts_hold_list_hs $ll
                
        delete-line-list
    }

    write-histoS_cf $histoS_cf
    print-messages $mess_list
    return 0
}


proc putit-hm {} {
    global  bin_hm  histoS_file log_file histoM_list histoM_cf
    global  host_hold_hm server_hold_hm
    set mess_list {}
    set host ""
    set server ""

    set mes [killit $host_hold_hm $server_hold_hm]
    if {$mes == -1} {return -1} else {print-messages $mes}

    foreach r $histoM_list {
	set host   [first  $r]
	set server [second $r]
    }
    if {$host == "" && $server == ""} {return 0}
    
    lappend mess_list "Putting $server $histoS_file $log_file on machine $host"
    set z [catch {exec putit -h $host $server  "$bin_hm $server $histoS_file $log_file"} m]
    if {$z} {
       set tmp {}; lappend tmp $m; print-messages $tmp; return -1
    } else {
       lappend mess_list $m
    }
    set z [catch {exec chmodit -h $host $server "i+all"} m]
    if {$z} {
       set tmp {}; lappend tmp $m; print-messages $tmp; return -1
    } else {
       lappend mess_list $m
    }
    set z [catch {exec chmodit -h $host $server "l+all"} m]
    if {$z} {
       set tmp {}; lappend tmp $m; print-messages $tmp; return -1
    } else {
       lappend mess_list $m
    }
    set host_hold_hm   $host
    set server_hold_hm $server

    write-histoM_cf $histoM_cf
    print-messages $mess_list
    return 0
}

proc putit-brg {} {
    global  bin_brg  histoM_file  histoB_list 
    global  host_hold_brg server_hold_brg users_queue
    set mess_list {}
    set host ""; set server ""

    set mes [killit $host_hold_brg $server_hold_brg]
    if {$mes == -1} {return -1} else {print-messages $mes}

    foreach r $histoB_list {
	set host   [first  $r]
	set server [second $r]
    }
    if {$host == "" && $server == ""} {return 0}

    set cmd "$bin_brg $server $histoM_file"
    lappend mess_list "Putting $server $histoM_file on machine $host"
    if [catch {exec putit -h $host $server "$cmd"} m] {
       set tmp {}; lappend tmp $m; print-messages $tmp; return -1
    } else {
       lappend mess_list $m
    }
    if [catch {exec chmodit -h $host $server "i+all"} m] {
       set tmp {}; lappend tmp $m; print-messages $tmp; return -1
    }  else {
       lappend mess_list $m
    }
    if [catch {exec chmodit -h $host $server "l+all"} m] {
       set tmp {}; lappend tmp $m; print-messages $tmp; return -1
    } else {
       lappend mess_list $m
    }
    set host_hold_brg   $host
    set server_hold_brg $server
   
    set job "Bridge"; set output ""; set lfile ""; set rfile ""
    set out [bsub $users_queue $host $job $output $lfile $rfile $cmd]
    lappend mess_list $out
    print-messages $mess_list
    return 0
}


proc putit-all {} {
     if {[putit-hm]  == -1} then {return -1}
     if {[putit-hs]  == -1} then {return -1}
     if {[putit-brg] == -1} then {return -1}
     return 0
}


proc install {} {
   global histoM_conf histoS_conf histoB_conf
   global frame_name mytaskfirstname
   global install_needed_hm install_needed_hs install_needed_brg

   if {$install_needed_hm == 0 && $install_needed_hs == 0 &&
       $install_needed_brg == 0} {return 1}
   
   set title ""
   if {$install_needed_hm}  {set title "Manager"}
   if {$install_needed_hs}  {set title "$title - Servers"}
   if {$install_needed_brg} {set title "$title - Bridge"}
   
   set i [midas-confirmation \
       "Histogrammer $title - Installation\n\n\
       This operation will \n\
       KILL any existing server,\n\
       and PUT (start) a new server \n\
       Do you wish to continue?"]

   if {$i} then {
      if {[putit-all] == -1} then {
         if {$install_needed_hm} {
            inform $mytaskfirstname cancel-histoM_conf
         }
         if {$install_needed_hs} {
            inform $mytaskfirstname cancel-histoS_conf
            delete-line-list
         }   
         if {$install_needed_brg} {
            inform $mytaskfirstname cancel-histoB_conf
         }
         return -1
      }
      if {$install_needed_hm}  {write-histoM_conf $histoM_conf}
      if {$install_needed_hs}  {write-histoS_conf $histoS_conf}
      if {$install_needed_brg} {write-histoB_conf $histoB_conf}
   } else {
     if {$install_needed_hm} {inform $mytaskfirstname cancel-histoM_conf}
     if {$install_needed_hs} {inform $mytaskfirstname cancel-histoS_conf}
     if {$install_needed_brg} {inform $mytaskfirstname cancel-histoB_conf}
   }
   set install_needed_hm  0; set install_needed_hs 0
   set install_needed_brg 0
   clear-footer
   return 0
}
   
   
   
#####################  START  #############################

proc start args {
   global started edit debug install_needed_hm install_needed_hs

   insert-debug "start: args = $args"

   set edit   	[first  $args]
   set cancel 	[second $args]
   set dataM    [third  $args]
   set dataS    [fourth $args]
   set dataB    [fifth  $args]
    
   if {$cancel} {
      set install_needed_hm 0
      set install_needed_hs 0
      delete-line-list
      clear-footer
   }
#   init-environment  -  done in common.beSetup
   init-parameters
   if {$started != 0} then {
       open-frame
   } else {
       make-frame
       set started 1
   }
   centre-frame
   display-histoM_conf $dataM
   display-histoS_conf $dataS
   display-histoB_conf $dataB
}

