# beSetup-nv.tcl---Back End Setup Network Variables Frame
 
loadsource common.lnl
loadsource common.orbix
loadsource common.$mytaskfirstname

set icontitle 	  "nvSetup"

#-------------- Server Variables -----------------------
set label_ns "Network Variables Server"

set netvarS_line_select {}
set netvarS_list 	 {}
set netvarS_conf 	""
set netvarS_cf   	 ""
set open_frame_mod_ns	 0
set install_needed_ns 0

set server_ns 	""
set server_hold_ns 	""
set bin_ns 	""

set servers_persistent_list_ns 	{}
set servers_allocate_list_ns {}
set servers_available_list_ns 	{}

#-------------- Manager Variables -----------------------
set label_nm "Network Variables Manager"

set netvarM_line_select {}
set netvarM_list {}
set netvarM_conf        ""
set netvarM_cf ""
set netvarM_file 	""

set open_frame_mod_nm    0
set install_needed_nm 0

set host_nm   ""
set host_hold_nm   ""
set server_nm ""
set server_hold_nm ""
set bin_nm    ""

set servers_persistent_list_nm {}
set servers_allocate_list_nm {}
set servers_available_list_nm  {}


#####################  FRAMES  #############################

proc make-frame {} {
   global env edit 
   global netvarS_conf netvarM_conf  

   if {$edit} then {set option_list F; set inactive F}\
              else {set option_list T; set inactive T}

   :frame [self frame-name] :label [self frame-title] :show-footer T \
      :icon-image "@$env(ICONHOME)/euroball" \
      :icon-name [self icon-title] :resize F

      :panel BEGIN :layout T; :layout H; :button QUIT :padx 45

      :panel NM_TITLE :layout T :padx 10 :pady 10 
    	 :layout H
         :message NM_TTL_1 :label "Manager Configuration File :" 
         :message NM_TTL_2 :label "$netvarM_conf"

      :panel NM_DATA :layout T :padx 10 :pady 0 
   	 :layout V
	 :message NM_MESS :label "Host Name \tServer Name \tLogger File"
         :list NM_LIST :rows 1 :cols 60 :exclusive T :deaf $option_list
 
      :panel NM_ACTIONS :layout T :padx 10 :pady 5 
   	 :layout H
	 :button NM_MODIFY :label "Modify..." :padx 10 :inactive $inactive

       :vskip 30

      :panel NS_TITLE :layout T :padx 10 :pady 5 
   	 :layout H
         :message NS_TTL_1 :label "Server Configuration File :" 
         :message NS_TTL_2 :label "$netvarS_conf"
 
      :panel NS_DATA :layout T :padx 10 :pady 0 
   	 :layout V
	 :message NS_MESS :label "Server Name \tConfiguration File \tLogger File"
         :list NS_LIST :rows 1 :cols 60 :exclusive T :deaf $option_list

      :panel NS_ACTIONS :layout T :padx 10 :pady 5
   	 :layout H
	 :button NS_MODIFY :label "Modify..." :padx 10 :inactive $inactive

   :show T
}

proc make-frame-modify-nm {} {
   global  host_nm  server_nm open_frame_mod_nm
   global  hosts_list servers_available_list_nm
   global  label_nm env netvarM_line_select

   click-list-nm $netvarM_line_select
   select-line-netvarM

   :frame [self frame-name].nm :label "$label_nm : Modify" \
	:show-footer T \
	:icon-image "@$env(ICONHOME)/euroball" \
	:icon-name [self icon-title] :resize F
	
        :panel NM_MOD_PARAM :layout T :padx 50 :pady 20 
     	   :layout V 
   	   :choice-stack NM_HOST :label Host  :strings $hosts_list :value [lsearch $hosts_list $host_nm]
           :row-gap 8
  	   :menubutton NM_SERVERMENU :label Server  :menu $servers_available_list_nm
 	   :layout H
 	   :text NM_SERVER :label "" :w 15  :value "$server_nm"

        :panel-dialog 40 CANCEL "click-mod-cancel-nm"  APPLY "click-mod-apply-nm" 
        	       
   :show T

   set open_frame_mod_nm 1
   }


proc make-frame-modify-ns {} {
   global server_ns servers_available_list_ns
   global open_frame_mod_ns netvarS_line_select
   global label_ns env

   click-list-ns $netvarS_line_select
   select-line-netvarS

   :frame [self frame-name].ns :label "$label_ns : Modify" :show-footer T \
        :icon-image "@$env(ICONHOME)/euroball" \
	:icon-name [self icon-title] :resize F

        :panel NS_MOD_PARAM :layout T :padx 50 :pady 20 
           :layout V 
  	   :menubutton NS_SERVERMENU :label Server :menu $servers_available_list_ns
 	   :layout H
 	   :text NS_SERVER :label "" :w 15  :value "$server_ns" 

        :panel-dialog 40 CANCEL "click-mod-cancel-ns"  APPLY "click-mod-apply-ns" 
        	       
   :show T

   set open_frame_mod_ns 1
   }

#####################  PROC  #############################

#-------------------------  parameters ---------------------------------

proc init-parameters {} {
    global bin_ns bin_nm
    global log_file netvarM_file 
    global netvarS_conf netvarM_conf netvarS_cf netvarM_cf
    global env edit frametitle

    if {$edit} then {
       set frametitle "Network Variables Configuration Tool (Edit)"
    } else {
       set frametitle "Network Variables Configuration Tool (Display)"
    }
 
    set bin_ns	     "$env(EB_BIN)/NetVarServer"
    set bin_nm	     "$env(EB_BIN)/NetVarManager"

    set log_file     "log.cf"
    set netvarM_file "netvarM.cf"
    set netvarS_conf "$env(EB_ETC)/netvarS.conf"
    set netvarM_conf "$env(EB_ETC)/netvarM.conf"
    set netvarS_cf   "$env(EB_CONFIG)/netvarS.cf"
    set netvarM_cf   "$env(EB_CONFIG)/netvarM.cf"

    init-servers-nm
    init-servers-ns
}

proc init-servers-nm {} {
    global servers_available_list_nm servers_allocate_list_nm
    global servers_persistent_list_nm

    set servers_persistent_list_nm {NetVarManager}
    set servers_allocate_list_nm {}
    set servers_available_list_nm  $servers_persistent_list_nm
    }

proc init-servers-ns {} {
    global servers_available_list_ns servers_allocate_list_ns
    global servers_persistent_list_ns

    set servers_persistent_list_ns {NetVarServer}
    set servers_allocate_list_ns {}
    set servers_available_list_ns  $servers_persistent_list_ns
    }

proc display-ns {} {
    global  server_ns

    :modify NS_SERVER :value " $server_ns"
    }

proc display-nm {} {
    global  host_nm server_nm hosts_list

    :modify NM_HOST   :value [lsearch $hosts_list $host_nm]
    :modify NM_SERVER :value " $server_nm"
    }


#-------------------------  manager ------------------------------------

proc write-netvarM_conf {fn } {
    global  netvarM_list

    set header { {# Configuration file for NetVar Manager}
	      {#}
	      {# host		 servername	     log-config}
	      {#} }

    set data [concat $header $netvarM_list]
    write-file $fn $data
    distribution $fn   
    }

proc write-netvarM_cf {fn } {
    global  netvarM_list

    foreach r $netvarM_list {
	set host   [first  $r]
	set server [second $r]
	}
	
    set data [list "$host\t :$server"]
    write-file $fn $data
    distribution $fn
    }

proc display-netvarM_conf {data} {
   global netvarM_list edit
   set netvarM_list {}

   foreach r $data {lappend netvarM_list [get-line-netvarM $r]}
   if {[llength $netvarM_list] >= 0 } {select-line-netvarM}
   if {!$edit} {deselect-line-netvarM}
   }

proc get-line-netvarM {ps} {
   global host_hold_nm server_hold_nm

   set host      [first $ps]
   set server    [second $ps]
   set log_file  [third $ps]

   set host_hold_nm   $host
   set server_hold_nm $server

   return [format-netvarM-line $host $server $log_file]
   }

proc format-netvarM-line {h s lf} {

   format " %-12s %-22s %s" $h $s $lf
   }

proc select-line-netvarM {} {
   global  netvarM_list netvarM_line_select

   :modify NM_LIST :empty T :append T :strings $netvarM_list :select 0
   set netvarM_line_select [lindex $netvarM_list 0]
   }
   
proc deselect-line-netvarM {} {
   global  netvarM_list

   :modify NM_LIST :empty T :append T :strings $netvarM_list :deselect 0
   }

proc modify-netvarM {} {
   global netvarM_list host_nm server_nm log_file 
   
   set r [format-netvarM-line $host_nm $server_nm $log_file]
   set netvarM_list [list $r]
   select-line-netvarM
   }


#-------------------------  server ------------------------------------

proc write-netvarS_conf {fn } {
    global  netvarS_list

    set header { {# Configuration file for Network Variables Server}
 	      {# each line contains the definition of an histo server}
	      {# and has the following fields}
	      {#}
	      {# servername	      NVM-config	  log-config}
	      {#} }

    set data [concat $header $netvarS_list]
    write-file $fn $data
    distribution $fn
    }

proc write-netvarS_cf {fn } {
    global  netvarS_list

    foreach r $netvarS_list {set server [first $r]}
    set data [list ":$server"]
    write-file $fn $data
    distribution $fn
    }

proc display-netvarS_conf {data} {
   global netvarS_list  edit
   set netvarS_list {}

   foreach r $data {lappend netvarS_list [get-line-netvarS $r]}
   if {[llength $netvarS_list] >= 0 } {
      select-line-netvarS
      if {!$edit} {deselect-line-netvarS}
      }
   }

proc get-line-netvarS {ps} {
   global servers_allocate_list_ns servers_available_list_ns 

   set server 	    [first $ps]
   set netvarM_f    [second $ps]
   set log_f  	    [third $ps]

   lappend servers_allocate_list_ns $server

   set servers_available_list_ns [ldelete $servers_available_list_ns \
					  $server]

   return [format-line-netvarS $server $netvarM_f $log_f]
   }


proc format-line-netvarS {s nf lf} {

   format " %-21s %-20s %s" $s $nf $lf
   }


proc select-line-netvarS {} {
   global netvarS_list netvarS_line_select

   :modify NS_LIST :empty T :append T :strings $netvarS_list :select 0
   set netvarS_line_select [lindex $netvarS_list 0]
   }

proc deselect-line-netvarS {} {
   global  netvarS_list

   :modify NS_LIST :empty T :append T :strings  $netvarS_list :deselect 0
   }

proc modify-netvarS {} {
   global netvarS_line_select netvarS_list
   global log_file netvarM_file server_ns server_hold_ns
   global servers_allocate_list_ns servers_available_list_ns

   set r [format-line-netvarS $server_ns $netvarM_file $log_file]
   set netvarS_list [list $r]
   select-line-netvarS

   set i [lsearch -exact $servers_allocate_list_ns $server_hold_ns]
   if {$i >= 0} then {
      set servers_allocate_list_ns [lreplace $servers_allocate_list_ns \
					     $i $i $server_ns]
      }
   set i [lsearch -exact $servers_available_list_ns $server_ns]
   if {$i >= 0} then {
      set servers_available_list_ns [lreplace $servers_available_list_ns \
					      $i $i $server_hold_ns]
      }
   }



#####################  CLICK  #############################

proc click {arg} {
   global debug hosts_list

   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]

   if {$c==":quit"} then {click-quit $f; return}

   switch  $w {
      NM_LIST 		{click-list-nm $v}
      NM_MODIFY 	      {click-modify-nm}
      NM_HOST 		{click-host-nm [lindex $hosts_list $v]}
      NM_SERVERMENU 	-
      NM_SERVER      	{click-server-nm $v}

      NS_LIST 		{click-list-ns $v}
      NS_MODIFY     	{click-modify-ns}
      NS_SERVERMENU 	-
      NS_SERVER   	{click-server-ns $v}

      QUIT 	      	{click-quit $f}

      default {puts stdout $arg}
   }
}

proc click-quit {f} {
    global install_needed_ns netvarS_conf mytaskfirstname
    global label_nm install_needed_nm netvarM_conf
    global open_frame_mod_ns open_frame_mod_nm

    switch -glob $f {
      *NS {set open_frame_mod_ns 0; close-frame $f}
      *NM {set open_frame_mod_nm 0; close-frame $f}
      default {
          if {$open_frame_mod_ns} then {
             set open_frame_mod_ns 0
             close-frame [self frame-name].ns
          }
          if {$open_frame_mod_nm} then {
             set open_frame_mod_nm 0
             close-frame [self frame-name].nm
          }     
          close-frame $f
      }
    }
    clear-footer
    inform $mytaskfirstname quit-netvar
    set open_frame_mod_ns 0
    set open_frame_mod_nm 0
}


#---------------- Manager ------------------------------------

proc click-list-nm {e} {
   global host_nm server_nm  netvarM_file log_file
   global netvarM_line_select open_frame_mod_nm label_nm

   set-footer "$label_nm: line selected..."

   set netvarM_line_select $e
   set host_nm     [first $e]
   set server_nm   [second $e]
#   set log_file    [third $e]

   if {$open_frame_mod_nm} {display-nm}
}

proc click-modify-nm {} {
   global label_nm

   set-footer "$label_nm: modify..."
   make-frame-modify-nm
}

proc click-mod-apply-nm {} {
   global  host_nm server_nm label_nm install_needed_nm
   global  open_frame_mod_nm netvarM_list mytaskfirstname

   if {$install_needed_nm} then {
      set-footer "$label_nm: install (needed)..."
      set z [expr [llength $host_nm] && [llength $server_nm]]
      if {$z == 0} then {
         set-footer [self frame-name].nm "Choice parameters in the menu list !!!"
         set-footer "$label_nm: Error !!!"
         display-error "Entry invalid parameter : null value"
         clear-footer
         set open_frame_mod_ns 0
         return
      }
      modify-netvarM
   } else {
      select-line-netvarM
   }
   set open_frame_mod_nm 0
   inform $mytaskfirstname update-netvarM_conf $netvarM_list
   close-frame [self frame-name].nm
}
 
proc click-mod-cancel-nm {} {
   global  open_frame_mod_nm install_needed_nm

   set install_needed_nm 0
   set open_frame_mod_nm 0

   close-frame [self frame-name].nm
}

proc click-host-nm {h} {
   global host_nm install_needed_nm host_nm
   global hosts_list

   clear-footer [self frame-name].nm
   set host_nm $h
   :modify NM_HOST :value [lsearch $hosts_list $host_nm]
   set install_needed_nm 1
}

proc click-server-nm {s} {
   global server_nm install_needed_nm

   clear-footer [self frame-name].nm
   set server_nm $s
   :modify NM_SERVER :value " $server_nm"
   set install_needed_nm 1
}

#---------------- Server ------------------------------------

proc click-list-ns {e} {
   global server_ns netvarM_ns log_file
   global netvarS_line_select netvarS_list
   global open_frame_mod_ns label_ns

   set-footer "$label_ns: line selected..."

   set netvarS_line_select $e
   set server_ns    [first $e]
#   set netvarM_ns  [second $e]
#   set log_file    [third $e]

   if {$open_frame_mod_ns} {display-ns}
}

proc click-modify-ns {} {
   global  label_ns

   set-footer "$label_ns: modify..."
   make-frame-modify-ns
}

proc click-server-ns {s} {
   global server_ns install_needed_ns

   clear-footer [self frame-name].ns
   set server_ns $s
   :modify NS_SERVER :value " $server_ns"
   set install_needed_ns 1
}

proc click-mod-apply-ns {} {
   global  server_ns install_needed_ns netvarS_list mytaskfirstname
   global  open_frame_mod_ns label_ns

   if {$install_needed_ns} then {
      set-footer "$label_ns: install (needed)..."
      set z [llength $server_ns]
      if {$z == 0} then {
         set-footer [self frame-name].ns "Choice parameters in the menu list !!!"
         set-footer "$label_ns: Error !!!"
         display-error "Entry invalid parameter : null value"
         clear-footer
         set open_frame_mod_ns 0
         return
      }
      modify-netvarS
   } else {
      select-line-netvarS
   }
 
   set open_frame_mod_ns 0
   inform $mytaskfirstname update-netvarS_conf $netvarS_list
   close-frame [self frame-name].ns
}
 
proc click-mod-cancel-ns {} {
   global  open_frame_mod_ns install_needed_ns
   
   set install_needed_ns 0
   set open_frame_mod_ns 0

   select-line-netvarS
   close-frame [self frame-name].ns
   }

#----------------- proc installation -------------------------------

proc putit-ns {} {
    global bin_ns netvarS_list netvarS_cf
    global server_hold_ns hosts_list netvarM_file log_file
    set mess_list {}

    foreach r $netvarS_list {set server [first $r]}

    foreach host $hosts_list {
        set mes [killit $host $server_hold_ns]
        if {$mes == -1} {return -1} else {print-messages $mes}

        lappend mess_list "Putting (starting) $server on machine $host"
	  set z [catch {exec putit -h $host $server \
			  "$bin_ns $server $netvarM_file $log_file"} m]
	  if {$z} {print-messages "$m"; return -1}
	  lappend mess_list $m

        set z [catch {exec chmodit -h $host $server "i+all"} m]
	  if {$z} {print-messages "$m"; return -1}
        lappend mess_list $m

        set z [catch {exec chmodit -h $host $server "l+all"} m]
	  if {$z} {print-messages "$m"; return -1}
        lappend mess_list $m
    }

    set server_hold_ns $server

    write-netvarS_cf $netvarS_cf
    print-messages $mess_list
    return 0
}

proc putit-nm {} {
    global  bin_nm  netvarS_file log_file netvarM_list netvarM_cf
    global  host_hold_nm  server_hold_nm
    set mess_list {}
    set host_nm  ""; set server_nm  ""

    set mes [killit $host_hold_nm $server_hold_nm]
    if {$mes == -1} {return -1} else {print-messages $mes}

    foreach r $netvarM_list {
	set host_nm    [first  $r]
	set server_nm  [second $r]
    }

    lappend mess_list "Putting (starting) $server_nm on machine $host_nm"
    set z [catch {exec putit -h $host_nm  $server_nm  \
		       		"$bin_nm  $server_nm $log_file"} m]
    if {$z} {print-messages "$m"; return -1}
    lappend mess_list $m

    set z [catch {exec chmodit -h $host_nm $server_nm "i+all"} m]
    if {$z} {print-messages "$m"; return -1}
    lappend mess_list $m

    set z [catch {exec chmodit -h $host_nm $server_nm "l+all"} m]
    if {$z} {print-messages "$m"; return -1}
    lappend mess_list $m
	   
    set host_hold_nm    $host_nm
    set server_hold_nm  $server_nm

    write-netvarM_cf $netvarM_cf
    print-messages $mess_list
    return 0
}

proc putit-all {} {
     if {[putit-nm]  == -1} then {return -1}
     if {[putit-ns]  == -1} then {return -1}
     return 0
}

proc install {} {
   global netvarM_conf netvarS_conf install_needed_nm install_needed_ns
   global mytaskfirstname

   if {$install_needed_nm == 0 && $install_needed_ns == 0} {return 1}
   
   if {$install_needed_nm} {set title "Manager"}
   if {$install_needed_ns} {set title "Servers"}
   if {$install_needed_nm != 0 && $install_needed_ns != 0} {set title "Manager & Servers"}
   
   set i [midas-confirmation \
       "Network Variables $title - Installation\n\n\
       This operation will \n\
       KILL any existing $title,\n\
       and PUT (start)new $title \n\
       Do you wish to continue?"]

   if {$i} then {
      if {[putit-all] == -1} then {
         if {$install_needed_nm} {inform $mytaskfirstname cancel-netvarM_conf}
         if {$install_needed_ns} {inform $mytaskfirstname cancel-netvarS_conf}   
         return -1
      }
      if {$install_needed_nm}  {write-netvarM_conf $netvarM_conf}
      if {$install_needed_ns}  {write-netvarS_conf $netvarS_conf}
   } else {
     if {$install_needed_nm} {inform $mytaskfirstname cancel-netvarM_conf}
     if {$install_needed_ns} {inform $mytaskfirstname cancel-netvarS_conf}
   }

   set install_needed_nm  0
   set install_needed_ns 0
   clear-footer
   return 0
}
   
   
#####################  START  #############################

proc start args {
    global started edit install_needed_nm install_needed_ns

    set edit      [first $args]
    set cancel    [second $args]
    set dataM     [third $args]
    set dataS     [fourth $args]

    if {$cancel} {
      set install_needed_nm 0
      set install_needed_ns 0
      clear-footer
    }
#   init-environment  -  done in common.beSetup
    init-parameters
    if {$started != 0} then {
       open-frame
    } else {
       make-frame
       set started 1
    }
    centre-frame
    display-netvarS_conf $dataS
    display-netvarM_conf $dataM
}
