# beSetup-tp.tcl---Back End Setup Tape frame
 
loadsource common.lnl
loadsource common.orbix
loadsource common.$mytaskfirstname

set icontitle     "tpSetup"
set frame_name_ts [self frame-name].ts_mod
set frame_name_tm [self frame-name].tm_mod

#-------------- Servers Variables -----------------------
set label_ts "Tape Servers"

set tapeS_line_select {}
set tapeS_list        {}
set tapeS_conf 	      ""
set tapeS_cf 	      ""
set tapeS_file 	      ""

set open_frame_mod_ts 0
set install_needed_ts 0 

set host_ts 	""
set port 	""
set port_hold 	""
set server_ts 	""
set server_hold_ts  ""
set device 	""
set juke	""
set type        ""
set generic 	""
set stat        ""
set bin_ts	""

set servers_hold_list_ts {}
set hosts_hold_list_ts   {}

set ports_allocate_list        {}
set ports_available_list       {}
set servers_persistent_list_ts {}
set servers_allocate_list_ts   {}
set servers_available_list_ts  {}
set types_persistent_list      {}
set generics_persistent_list   {}

#-------------- Manager Variables -----------------------
set label_tm "Tape Manager"

set tapeM_line_select {}
set tapeM_list        {}
set tapeM_conf 	      ""
set tapeM_cf          ""

set open_frame_mod_tm 0
set install_needed_tm 0

set host_tm        ""
set host_hold_tm   ""
set server_tm      ""
set server_hold_tm ""
set max_exp          0
set capab 	     0
set bin_tm         ""

set servers_persistent_list_tm {}
set servers_allocate_list_tm   {}
set servers_available_list_tm  {}


#####################  FRAMES  #############################

proc make-frame {} {
   global env user_font frame_name frametitle edit
   global line_index tapeS_conf tapeM_conf

   if {$edit} then {
      set option_list F; set option_foot T; set inactive F
   } else {
      set option_list T; set option_foot F; set inactive T
      set line_index -1
   }

   :frame [self frame-name] :label [self frame-title] :show-footer $option_foot \
     :icon-image "@$env(ICONHOME)/euroball" \
     :icon-name [self icon-title] :resize F

     :panel BEGIN :layout T
        :layout H
        :button QUIT :padx 45

     :panel TITLE :layout T :padx 10 :pady 10 
   	:layout H
        :message TTL_1 :label "Servers Configuration File :" 
        :message TTL_2 :label "$tapeS_conf"
  
     :panel DATA :layout T :padx 10 :pady 0 
   	:layout V
	:message MESS :bold F :label \
			"Host Name\tServer Name\t    Device Name\
			 \t\tJuke Name\tType\
			 \tGeneric   Port Number\
			 \tStatistics  Logger File"
        :list LIST :rows 5 :cols 120 :exclusive T :deaf $option_list

     :panel ACTIONS :layout T :padx 10 :pady 5
   	:layout H
	:button ADD    :label "Add..."    :padx 18 :inactive $inactive
	:button MODIFY :label "Modify..." :padx 10 :inactive $inactive
	:button DELETE :label "Delete..." :padx 10 :inactive $inactive

     :panel TM_TITLE :layout T :padx 10 :pady 9
   	:layout H
        :message TM_TTL_1 :label "Manager Configuration File :" 
        :message TM_TTL_2 :label "$tapeM_conf"

     :panel TM_DATA :layout T :padx 10 :pady 0 
   	:layout V
	:message TM_MESS :bold F :label \
			"Host Name\tServer Name\
			 \t\tConfiguration File     Max Experiments\
			 \tCapability\tLogger File"
        :list TM_LIST :rows 1 :cols 100 :exclusive T :deaf $option_list
 
     :panel TM_ACTIONS :layout T :padx 10 :pady 5 
   	:layout H
	:button TM_MODIFY :label "Modify... " :padx 10 :inactive $inactive

   :show T
}

proc make-frame-modify-ts {} {
   global host_ts server_ts device juke type  generic stat port
   global fhosts_list servers_available_list_ts
   global ports_available_list types_persistent_list
   global generics_persistent_list
   global modify add open_frame_mod_ts tapeS_line_select
   global frame_name_ts label_ts env

   set title ""; set label ""

   if {$modify} then {
      set title "$label_ts : Modify"
      set label "Apply"
      click-list-ts $tapeS_line_select
      select-line-tapeS
   }

   if {$add} then {
      set title "$label_ts : Addition"
      set label "Add"
      set host_ts ""; set server_ts ""; set device ""; set juke ""
      set type ""; set generic ""; set stat ""; set port ""
      deselect-line-tapeS
   }

   :frame $frame_name_ts :label $title :show-footer T \
        :icon-image "@$env(ICONHOME)/euroball" \
	:icon-name [self icon-title] :resize F

        :panel MOD_PARAM :layout T :padx 20 :pady 20 
     	   :layout H; :row-gap 5
    	   :choice-stack TS_HOST :label Host :strings $fhosts_list \
			 :value [lsearch $fhosts_list $host_ts]
           :next-row T
   	   :menubutton TS_PORTMENU   :label Port :menu $ports_available_list
  	   :text TS_PORT :label "" :w 6 :deaf T :value $port
	   :next-row T
  	   :menubutton TS_TYPEMENU :label Type :menu $types_persistent_list
  	   :text TS_TYPE :label "" :w 13 :deaf T :value $type
           :next-row T
  	   :menubutton TS_GENERICMENU :label Generic :menu $generics_persistent_list
  	   :text TS_GENERIC :label "" :w 3 :deaf T :value $generic
           :next-row T
           :layout V
  	   :text TS_DEVICE :label Device     :w 30 :valuex 12c :value $device
   	   :text TS_SERVER :label Server     :w 20 :valuex 12c :value $server_ts :deaf F
  	   :text TS_JUKE   :label Juke       :w 10 :valuex 12c :value $juke
  	   :text TS_STAT   :label Statistics :w 10 :valuex 12c :value $stat

        :panel-dialog 40 CANCEL "click-mod-cancel-ts" $label "click-mod-add-ts" 
        	       
   :show T

   set open_frame_mod_ts 1
}


proc make-frame-modify-tm {} {
   global  host_tm  server_tm max_exp capab 
   global  hosts_list servers_available_list_tm
   global  frame_name_tm label_tm env tapeM_line_select
   global  open_frame_mod_tm 

   click-list-tm $tapeM_line_select
   select-line-tapeM

   :frame $frame_name_tm :label "$label_tm : Modify" \
	:show-footer T \
	:icon-image "@$env(ICONHOME)/euroball" \
	:icon-name [self icon-title] :resize F
	
        :panel TM_MOD_PARAM :layout T :padx 20 :pady 20 
     	   :layout H; :row-gap 5
    	   :choice-stack TM_HOST :label Host :strings $hosts_list \
			 :value [lsearch $hosts_list $host_tm]
           :next-row T
  	   :menubutton TM_SERVERMENU :label Server :menu $servers_available_list_tm
 	   :text TM_SERVER :label "" :w 20 :value $server_tm
           :next-row T
  	   :choice TM_CAP :label Capability :strings [list "Off" "On"] :w 5 :value $capab
           :next-row T
  	   :number TM_EXP :label "Max Experiments" :w 2  :min 0 :max 10 :value $max_exp

        :panel-dialog 30 CANCEL "click-mod-cancel-tm"  APPLY "click-mod-add-tm" 
        	       
   :show T

   set open_frame_mod_tm 1
}


#####################  PROC  #############################

#-------------------------  parameters ---------------------------------

proc init-parameters {} {
    global bin_ts bin_tm
    global log_file tapeS_file 
    global tapeS_conf tapeM_conf tapeS_cf tapeM_cf
    global env edit frametitle

    if {$edit} then {
       set frametitle "Tape Configuration Tool (Edit)"
    } else {
       set frametitle "Tape Configuration Tool (Display)"
    }

    set bin_ts	   "$env(EB_BIN)/EB_TapeServer"
    set bin_tm	   "$env(EB_BIN)/EB_TapeManager"

    set log_file   "log.cf"
    set tapeS_file "tapeS.cf"
    set tapeS_conf "$env(EB_ETC)/tapeS.conf"
    set tapeM_conf "$env(EB_ETC)/tapeM.conf"
    set tapeS_cf   "$env(EB_CONFIG)/tapeS.cf"
    set tapeM_cf   "$env(EB_CONFIG)/tapeM.cf"

    init-ports-ts
    init-servers-ts
    init-servers-tm
    init-types-ts
    init-generics-ts
    init-experiments
}


proc init-ports-ts {} {
    global ports_available_list ports_list_tp

    set ports_available_list $ports_list_tp
}

proc init-types-ts {} {
    global types_persistent_list

    set types_persistent_list {juke_exabite juke_dlt exabyte dlt sink file}
}

proc init-generics-ts {} {
    global generics_persistent_list

    set generics_persistent_list {Magnetic_Tape File Sink Juke_Box}
}

proc init-servers-ts {} {
    global servers_available_list_ts servers_persistent_list_ts

    set servers_persistent_list_ts {
	TapeServer0 TapeServer1 TapeServer2 TapeServer3 TapeServer4 \
	TapeServer5 TapeServer6 TapeServer7}
    set servers_available_list_ts $servers_persistent_list_ts
}

proc init-servers-tm {} {
    global servers_available_list_tm servers_persistent_list_tm

    set servers_persistent_list_tm {TapeManager}
    set servers_available_list_tm  $servers_persistent_list_tm
}

proc init-experiments {} {global max_exp; set max_exp 1}

proc display-ts {} {
    global host_ts server_ts device juke type  generic stat port
    global fhosts_list

    :modify TS_HOST    :value [lsearch $fhosts_list $host_ts]
    :modify TS_SERVER  :value $server_ts
    :modify TS_DEVICE  :value $device
    :modify TS_JUKE    :value $juke
    :modify TS_TYPE    :value $type
    :modify TS_GENERIC :value $generic
    :modify TS_PORT    :value $port
    :modify TS_STAT    :value $stat
}

proc display-tm {} {
    global  hosts_list host_tm  server_tm max_exp capab 

    :modify TM_HOST   :value [lsearch $hosts_list $host_tm]
    :modify TM_SERVER :value $server_tm
    :modify TM_EXP    :value $max_exp
    :modify TM_CAP    :value $capab
}


#-------------------------  servers ------------------------------------

proc write-tapeS_conf {fn } {
    global  tapeS_list 

    set header { {# Configuration file for Tape Servers}
 	      {# each line contains the definition of an tape server}
	      {# and has the following fields}
	      {#}
{# host	       servername     device-name	     juke-name	     type   generic     port   statistics log-config}
	      {#} }

    set data [concat $header $tapeS_list]
    write-file $fn $data
    distribution $fn
}

proc write-tapeS_cf {fn } {
    global  tapeS_list

    set data {}
    foreach r $tapeS_list {
       lappend data "[first $r]\t :[second $r]"
    }
    write-file $fn $data
    distribution $fn
}

proc display-tapeS_conf {data} {
   global tapeS_list line_index edit 
   set tapeS_list {}

   foreach r $data {lappend tapeS_list [get-line-tapeS $r]}
   if {[llength $tapeS_list] != 0 } {
      set line_index 0
      select-line-tapeS
      if {!$edit} {deselect-line-tapeS}
   } 
}

proc get-line-tapeS {e} {
   global servers_allocate_list_ts ports_allocate_list
   global servers_available_list_ts ports_available_list
   global servers_hold_list_ts hosts_hold_list_ts

   set host    [first $e]
   set server  [second $e]
   set device  [third $e]
   set juke    [fourth $e]
   set type    [fifth $e]
   set generic [sixth $e]
   set port    [seventh $e]
   set stat    [eighth $e]
   set log_f   [ninth $e]

   lappend servers_allocate_list_ts $server
   lappend ports_allocate_list      $port

   lappend servers_hold_list_ts	    $server
   lappend hosts_hold_list_ts	    $host

   set servers_available_list_ts [\
		      ldelete $servers_available_list_ts $server]
   set ports_available_list [ldelete $ports_available_list $port]

   return [format-line-tapeS $host $server $device $juke $type \
			     $generic $port $stat $log_f]
}


proc format-line-tapeS {h s d j t g p st lf} {

   format " %-12s %-15s %-27s %-11s %-8s %-8s %-8d %-8d %s" \
	   $h $s $d $j $t $g $p $st $lf
}

proc select-line-tapeS {} {
   global line_index tapeS_list tapeS_line_select

   :modify LIST :empty T :append T :strings $tapeS_list :select $line_index

   set tapeS_line_select [lindex $tapeS_list $line_index]
}

proc deselect-line-tapeS {} {
   global line_index tapeS_list

   :modify LIST :empty T :append T :strings $tapeS_list :deselect $line_index
}

proc modify-tapeS {} {
   global host_ts server_ts device juke type generic stat port log_file
   global server_hold_ts port port_hold
   global tapeS_line_select line_index tapeS_list
   global ports_allocate_list ports_available_list
   global servers_allocate_list_ts servers_available_list_ts

   set r [format-line-tapeS $host_ts $server_ts $device $juke $type \
			    $generic $port $stat $log_file]

   if {$line_index != -1} {
      if {[llength $tapeS_list] >= 0} {
         set ll [lreplace $tapeS_list $line_index $line_index $r]
         set tapeS_list $ll
         select-line-tapeS

         set i [lsearch -exact $servers_allocate_list_ts $server_hold_ts]
    	 if {$i >= 0} then {
	    set servers_allocate_list_ts [\
		lreplace $servers_allocate_list_ts $i $i $server_ts]
	 }
         set i [lsearch -exact $servers_available_list_ts $server_ts]
    	 if {$i >= 0} then {
	    set servers_available_list_ts [\
		lreplace $servers_available_list_ts $i $i $server_hold_ts]
	 }

         set i [lsearch -exact $ports_allocate_list $port_hold]
    	 if {$i >= 0} then {
	    set ports_allocate_list [lreplace $ports_allocate_list $i $i $port]
	 }
         set i [lsearch -exact $ports_available_list $port]
    	 if {$i >= 0} then {
	    set ports_available_list [lreplace $ports_available_list $i $i $port_hold]
	 }

      }
   }
}

proc add-tapeS {} {
   global host_ts server_ts device juke type generic stat port log_file
   global  line_index tapeS_list
   global  servers_allocate_list_ts ports_allocate_list
   global  servers_available_list_ts ports_available_list

   set r [format-line-tapeS $host_ts $server_ts $device $juke $type \
			    $generic $port $stat $log_file]
   lappend tapeS_list [get-line-tapeS $r]
   set line_index [expr [llength $tapeS_list] - 1]
   select-line-tapeS

   set ports_available_list [ldelete $ports_available_list $port]
   lappend ports_allocate_list  $port

   set servers_available_list_ts [ldelete $servers_available_list_ts \
					  $server_ts]
   lappend servers_allocate_list_ts  $server_ts
}



#-------------------------  manager ------------------------------------

proc write-tapeM_conf {fn } {
    global  tapeM_list

    set header { {# Configuration file for Tape Manager}
	      {#}
{# host	     servername		       TS-config       MAX_EXP 	 use_capability  log-config}
	      {#} }

    set data [concat $header $tapeM_list]
    write-file $fn $data
    distribution $fn
}

proc write-tapeM_cf {fn } {
    global  tapeM_list

    foreach r $tapeM_list {
	set host   [first  $r]
	set server [second $r]
    }
    set data [list "$host\t :$server"]
    write-file $fn $data
    distribution $fn
}

proc display-tapeM_conf {data} {
   global tapeM_list edit
   set tapeM_list {}

   foreach r $data {lappend tapeM_list [get-line-tapeM $r]}
   if {[llength $tapeM_list] >= 0 } {select-line-tapeM} 
   if {!$edit} {deselect-line-tapeM}
}

proc get-line-tapeM {e} {
   global host_hold_tm server_hold_tm

   set host      [first $e]
   set server    [second $e]
   set conf_f    [third $e]
   set exp       [fourth $e]
   set cap       [fifth $e]
   set log_f     [sixth $e]

   set host_hold_tm   $host
   set server_hold_tm $server

   return [format-tapeM-line $host $server $conf_f $exp $cap $log_f]
}

proc format-tapeM-line {h s cf e c lf} {

   format " %-12s %-23s %-19s %-13d %-11d %s" $h $s $cf $e $c $lf
}

proc select-line-tapeM {} {
   global  tapeM_list tapeM_line_select

   :modify TM_LIST :empty T :append T :strings $tapeM_list :select 0
   set tapeM_line_select [lindex $tapeM_list 0]
}
   
proc deselect-line-tapeM {} {
   global  tapeM_list

   :modify TM_LIST :empty T :append T :strings $tapeM_list :deselect 0
}

proc modify-tapeM {} {
   global tapeM_list
   global host_tm server_tm max_exp capab tapeS_file log_file 
   
   set r [format-tapeM-line $host_tm $server_tm $tapeS_file $max_exp \
			    $capab $log_file]
   set tapeM_list [list $r]
   select-line-tapeM
}



#####################  CLICK  #############################

proc click {arg} {
   global debug hosts_list fhosts_list

   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]

   if {$c==":quit"} then {click-quit $f; return}

   switch  $w {
      LIST 	     {click-list-ts $v}
      MODIFY         {click-modify-ts}
      ADD 	     {click-add}
      DELETE         {click-delete}
      TS_HOST 	     {click-host-ts [lindex $fhosts_list $v]}
      TS_PORTMENU    -
      TS_PORT 	     {click-port-ts $v}
      TS_DEVICE      {click-device-ts $v}
      TS_SERVER      {click-server-ts $v}
      TS_JUKE 	     {click-juke-ts $v}
      TS_TYPEMENU    -
      TS_TYPE 	     {click-type-ts $v}
      TS_GENERICMENU -
      TS_GENERIC     {click-generic-ts $v}
      TS_STAT 	     {click-stat-ts $v}

      TM_LIST 	     {click-list-tm $v}
      TM_MODIFY      {click-modify-tm}
      TM_HOST 	     {click-host-tm [lindex $hosts_list $v]}
      TM_SERVERMENU  -
      TM_SERVER      {click-server-tm $v}
      TM_EXP 	     {click-exp-tm $v}
      TM_CAP 	     {click-cap-tm $v}

      QUIT 	     {click-quit $f}

      default 	     {puts stdout $arg}
   }
}

proc click-quit {f} {
    global open_frame_mod_ts open_frame_mod_tm
    global frame_name_ts frame_name_tm frame mytaskfirstname

    switch  $f {
      $frame.TS_MOD {set open_frame_mod_ts 0; close-frame $f}
      $frame.TM_MOD {set open_frame_mod_tm 0; close-frame $f}
      default {
          if {$open_frame_mod_ts} then {
             set open_frame_mod_ts 0
             close-frame $frame_name_ts
          }
          if {$open_frame_mod_tm} then {
             set open_frame_mod_tm 0
             close-frame $frame_name_tm
          }     
          close-frame $f
      }
    }
    clear-footer
    inform $mytaskfirstname quit-tape [winfo x .] [winfo y .]
    set open_frame_mod_tm 0
    set open_frame_mod_ts 0
}

#---------------- Servers ------------------------------------

proc click-list-ts {e} {
   global host_ts server_ts device juke type generic stat port 
   global log_file
   global tapeS_line_select line_index tapeS_list
   global open_frame_mod_ts add label_ts

   if {$add} {
       deselect-line-tapeS 
       return
   }

   set tapeS_line_select $e
   set line_index [lsearch -exact $tapeS_list $e]

   set line [expr $line_index + 1]
   set-footer "$label_ts: line $line selected..."

   set host_ts    [first $e]
   set server_ts  [second $e]
   set device     [third $e]
   set juke       [fourth $e]
   set type       [fifth $e]
   set generic    [sixth $e]
   set port       [seventh $e]
   set stat       [eighth $e]
#   set log_file   [ninth $e]

   if {$open_frame_mod_ts} {display-ts}
}


proc click-modify-ts {} {
   global  add modify label_ts tapeS_list

   if {$tapeS_list == {}} {return}
   set modify 1; set add 0
   set-footer "$label_ts: modify..."
   make-frame-modify-ts
}


proc click-add {} {
   global  add modify label_ts

   set-footer "$label_ts: add line..."
   set add 1; set modify 0
   make-frame-modify-ts
}

proc click-delete {} {
   global  tapeS_list line_index tapeS_line_select
   global  servers_allocate_list_ts ports_allocate_list
   global  servers_available_list_ts ports_available_list
   global  port server_ts label_ts frame_name add
   global  host_ts server_ts tapeS_cf tapeS_conf mytaskfirstname

   if {$tapeS_list == {}} {return}
   set add 0

   click-list-ts $tapeS_line_select
   set line [expr $line_index + 1]

   set d [midas-confirmation \
       "$label_ts - Delete\n\n\
       This operation will KILL the server \"$server_ts\"\n\
       Do you wish to continue?"]

   if {$d} then  {
      set i [lsearch -exact $tapeS_list $tapeS_line_select]
      if {$i >= 0} {
         set-busy-watch "Killing server \"$server_ts\" : Waiting..."
         set ll [lreplace $tapeS_list $i $i]
         set tapeS_list $ll
         set line_index 0
         select-line-tapeS

   	 set ports_allocate_list [ldelete $ports_allocate_list $port]
  	 lappend ports_available_list  $port

   	 set servers_allocate_list_ts [ldelete $servers_allocate_list_ts \
				    	       $server_ts]
   	 lappend servers_available_list_ts  $server_ts

         write-tapeS_conf $tapeS_conf

         set mes [killit $host_ts $server_ts]; print-messages $mes
         write-tapeS_cf $tapeS_cf

	 delete-line-list
         inform $mytaskfirstname update-tapeS_conf $tapeS_list
         clear-busy-watch
         set-footer "$label_ts: delete line $line..."
      }
   }
}

proc click-host-ts {h} {
   global host_ts frame_name_ts install_needed_ts

   clear-footer $frame_name_ts
   set host_ts $h
   set install_needed_ts 1
}

proc click-port-ts {p} {
   global port port_hold ports_available_list
   global frame_name_ts install_needed_ts

   clear-footer $frame_name_ts
   set port_hold $port
   set port $p
   :modify TS_PORT :value $port
   set install_needed_ts 1
}

proc click-type-ts {t} {
   global type label_ts frame_name_ts
   global install_needed_ts

   clear-footer $frame_name_ts
   set type $t
   :modify TS_TYPE :value $t
   set install_needed_ts 1
}

proc click-generic-ts {g} {
   global generic label_ts frame_name_ts
   global install_needed_ts

   clear-footer $frame_name_ts

   switch $g {
	Magnetic_Tape   {set generic MT}
	File		{set generic F}
	Sink		{set generic S}
	Juke_Box	{set generic JB}
   }

   :modify TS_GENERIC :value $generic
   set install_needed_ts 1
}


#/////////////////////////////
# This procedure modifie the server's name 
#
proc click-device-ts-new {d} {
   global device label_ts  server_ts server_hold_ts
   global frame_name_ts install_needed_ts

   clear-footer $frame_name_ts
   set device $d
   set server_hold_ts $server_ts
   set i [expr [string last "/" $d] + 1]
   set server_ts [string range $d $i end]

   :modify TS_DEVICE :value $d
   :modify TS_SERVER :value $server_ts
   set install_needed_ts 1
}

proc click-device-ts {d} {
   global device frame_name_ts install_needed_ts

   clear-footer $frame_name_ts
   set device $d

   :modify TS_DEVICE :value $d
   set install_needed_ts 1
}

proc click-server-ts {s} {
   global server_ts server_hold_ts frame_name_ts install_needed_ts

   clear-footer $frame_name_ts
   set server_hold_ts $server_ts
   set server_ts $s

   :modify TS_SERVER :value $server_ts
   set install_needed_ts 1
}

proc click-juke-ts {j} {
   global juke label_ts frame_name_ts
   global install_needed_ts

   clear-footer $frame_name_ts
   set juke $j
   :modify TS_JUKE :value $j
   set install_needed_ts 1
}
   
proc click-stat-ts {s} {
   global stat label_ts frame_name_ts
   global install_needed_ts

   clear-footer $frame_name_ts
   set stat $s
   :modify TS_STAT :value $s
   set install_needed_ts 1
}

proc click-mod-add-ts {} {
   global  host_ts server_ts port install_needed_ts
   global  modify add open_frame_mod_ts label_ts frame_name_ts
   global  tapeS_list mytaskfirstname

   if {$install_needed_ts} then {
      set-footer "$label_ts: install (needed)..."
      set z [expr [llength $host_ts] && [llength $server_ts] && \
	          [llength $port] ]
      if {$z == 0} then {
         set-footer $frame_name_ts "Choice parameters in the menu list !!!"
         set-footer "$label_ts: Error !!!"
         display-error "Entry invalid parameter : null value"
         clear-footer
         set open_frame_mod_ts 0
         return
      }
      if {$modify} {modify-tapeS }
      if {$add} {add-tapeS; select-line-tapeS}
   } else {
      select-line-tapeS
   }

   insert-line-list

   set add 0; set modify 0; set open_frame_mod_ts 0
   inform $mytaskfirstname update-tapeS_conf $tapeS_list
   close-frame $frame_name_ts
}
 
proc click-mod-cancel-ts {} {
   global  open_frame_mod_ts install_needed_ts frame_name_ts
   global  add modify
   
   set install_needed_ts 0; set open_frame_mod_ts 0
   set add 		 0; set modify 		  0

   select-line-tapeS
   close-frame $frame_name_ts
}


#---------------- Manager ------------------------------------

proc click-list-tm {e} {
   global host_tm server_tm  max_exp capab
   global label_tm open_frame_mod_tm

   set-footer "$label_tm: line selected..."

   set host_tm      [first $e]
   set server_tm    [second $e]
#   set tapeS_file   [third $e]
   set max_exp      [fourth $e]
   set capab        [fifth $e]
#   set log_file     [sixth $e]

   if {$open_frame_mod_tm} {display-tm}
}

proc click-modify-tm {} {
   global label_tm

   set-footer "$label_tm: modify..."
   make-frame-modify-tm
}

proc click-host-tm {h} {
   global host_tm frame_name_tm install_needed_tm

   clear-footer $frame_name_tm
   set host_tm $h
   set install_needed_tm 1
}

proc click-server-tm {s} {
   global server_tm frame_name_tm install_needed_tm

   clear-footer $frame_name_tm
   set server_tm $s
   :modify TM_SERVER :value $server_tm
   set install_needed_tm 1
}

proc click-exp-tm {e} {
   global max_exp frame_name_tm install_needed_tm

   clear-footer $frame_name_tm
   set max_exp $e
   :modify TM_EXP :value $e
   set install_needed_tm 1
}

proc click-cap-tm {c} {
   global capab frame_name_tm install_needed_tm

   clear-footer $frame_name_tm
   set capab $c
   :modify TM_CAP :value $c
   set install_needed_tm 1
}

proc click-mod-add-tm {} {
   global  host_tm server_tm label_tm install_needed_tm 
   global  open_frame_mod_tm frame_name_tm tapeM_list mytaskfirstname

   if {$install_needed_tm} then {
      set-footer "$label_tm: install (needed)..."
      set z [expr [llength $host_tm] && [llength $server_tm]]
      if {$z == 0} then {
         set-footer $frame_name_tm "Choice parameters in the menu list !!!"
         set-footer "$label_tm: Error !!!"
         display-error "Entry invalid parameter : null value"
         clear-footer
         set open_frame_mod_ts 0
         return
      }
      modify-tapeM
   } else {
      select-line-tapeM
   }
   set open_frame_mod_tm 0
   inform $mytaskfirstname update-tapeM_conf $tapeM_list
   close-frame $frame_name_tm
}
 
proc click-mod-cancel-tm {} {
   global  open_frame_mod_tm install_needed_tm frame_name_tm

   set install_needed_tm 0; set open_frame_mod_tm 0

   close-frame $frame_name_tm
}


#----------------- proc installation -------------------------------

proc putit-ts {} {
    global tapeS_list bin_ts tapeS_cf
    global servers_hold_list_ts hosts_hold_list_ts log_file
    set mess_list {}

    if {[llength $tapeS_list] == 0} {return 0}

    for {set i 0} {$i < [llength $tapeS_list]} {incr i} {
        set r 	    [lindex $tapeS_list $i]
	set host    [first   $r]
	set server  [second  $r]
	set device  [third   $r]
	set juke    [fourth  $r]
	set type    [fifth   $r]
	set generic [sixth   $r]
	set port    [seventh $r]
	set stat    [eighth  $r]
	set log_f   [ninth   $r]

        set server_hold [lindex $servers_hold_list_ts $i]
        set host_hold   [lindex $hosts_hold_list_ts   $i]

 	set mes [killit $host_hold $server_hold]
        if {$mes == -1} {return -1} else {print-messages $mes}

        lappend mess_list \
		"Putting $server $device $juke $type $generic $port \
			 $stat $log_f on machine $host"

	set z [catch {exec putit -h $host $server \
				   "$bin_ts $server $device $juke $type \
				    $generic $port $stat $log_f"} m]
	if {$z} {
	   set tmp {}; lappend tmp $m; print-messages $tmp; return -1
	} else {
	   lappend mess_list $m
	}
	set z [catch {exec chmodit -h $host $server "i+all"} m]
	if {$z} {
	   set tmp {}; lappend tmp $m; print-messages $tmp; return -1
	} else {
	   lappend mess_list $m
	}
	set z [catch {exec chmodit -h $host $server "l+all"} m]
	if {$z} {
	   set tmp {}; lappend tmp $m; print-messages $tmp; return -1
	} else {
	   lappend mess_list $m
	}
        set ll [lreplace $servers_hold_list_ts $i $i $server]
	set servers_hold_list_ts $ll
        set ll [lreplace $hosts_hold_list_ts $i $i $host]
	set hosts_hold_list_ts $ll
                
        delete-line-list
    }

    write-tapeS_cf $tapeS_cf
    print-messages $mess_list
    return 0
}

proc putit-tm {} {
    global  bin_tm  tapeS_file log_file tapeM_list tapeM_cf
    global  host_hold_tm server_hold_tm
    set mess_list {}
    set host ""; set server ""; set conf_f ""; set exp 0
    set cap 0; set log_f ""

    set mes [killit $host_hold_tm $server_hold_tm]
    if {$mes == -1} {return -1} else {print-messages $mes}

    foreach r $tapeM_list {
	set host      [first  $r]
	set server    [second $r]
	set conf_f    [third  $r]
	set exp       [fourth $r]
	set cap       [fifth  $r]
	set log_f     [sixth  $r]
    }

    lappend mess_list "Putting $server $conf_f $exp $cap $log_f on machine $host"
    set z [catch {exec putit -h $host $server "$bin_tm $server $conf_f $exp $cap $log_f"} m]
    if {$z} then {
       set tmp {}; lappend tmp $m; print-messages $tmp; return -1
    } else {
       lappend mess_list $m
    }
    set z [catch {exec chmodit -h $host $server "i+all"} m]
    if {$z} then {
       set tmp {}; lappend tmp $m; print-messages $tmp; return -1
    } else {
       lappend mess_list $m
    }
    set z [catch {exec chmodit -h $host $server "l+all"} m]
    if {$z} then {
       set tmp {}; lappend tmp $m; print-messages $tmp; return -1
    } else {
       lappend mess_list $m
    }
    set host_hold_tm   $host
    set server_hold_tm $server

    write-tapeM_cf $tapeM_cf
    print-messages $mess_list
    return 0
}

proc putit-all {} {
     if {[putit-tm]  == -1} then {return -1}
     if {[putit-ts]  == -1} then {return -1}
     return 0
}

proc install {} {
   global tapeM_conf tapeS_conf install_needed_tm install_needed_ts
   global frame_name mytaskfirstname

   if {$install_needed_tm == 0 && $install_needed_ts == 0} then {return 1}
   
   set title ""
   if {$install_needed_tm} then {set title "Manager"}
   if {$install_needed_ts} then {set title "$title - Servers"}
   
   set i [midas-confirmation \
       "Tape $title installation\n\n\
       This operation will \n\
       KILL any existing $title,\n\
       and PUT (start) a new $title \n\
       Do you wish to continue?"]

   if {$i} then {
      if {[putit-all] == -1} then {
         if {$install_needed_tm} {
            inform $mytaskfirstname cancel-tapeM_conf
         }
         if {$install_needed_ts} {
            inform $mytaskfirstname cancel-tapeS_conf
            delete-line-list
         }   
         return -1
      }
      if {$install_needed_tm}  {write-tapeM_conf $tapeM_conf}
      if {$install_needed_ts}  {write-tapeS_conf $tapeS_conf}
   } else {
     if {$install_needed_tm} {inform $mytaskfirstname cancel-tapeM_conf}
     if {$install_needed_ts} {inform $mytaskfirstname cancel-tapeS_conf}
   }
   set install_needed_tm  0; set install_needed_ts 0
   clear-footer
   return 0
}
   
#####################  START  #############################

proc start args {
   global started edit install_needed_tm install_needed_ts

   set edit   [first  $args]
   set cancel [second $args]
   set dataM  [third  $args]
   set dataS  [fourth $args]
   
   if {$cancel} {
      set install_needed_tm 0
      set install_needed_ts 0
      delete-line-list
      clear-footer
   }
#   init-environment  -  done in common.beSetup
   init-parameters
   if {$started != 0} then {
       open-frame
   } else {
       make-frame
       set started 1
   }
   centre-frame
   display-tapeM_conf $dataM
   display-tapeS_conf $dataS
}

