# beSetup.tcl---Back End Setup histogrammer frame

loadsource common.lnl
loadsource common.orbix
loadsource common.$mytaskfirstname

set icontitle  "beSetup"

set open_frame_evFarm  0; set open_frame_spyFarm 0
set open_frame_log     0; set open_frame_histo   0
set open_frame_netvar  0; set open_frame_tape    0
set open_frame_spy     0

set evFarm_data  {}; set spyFarm_data  {}; set log_data   {}
set histoM_data  {}; set netvarM_data  {}; set tapeM_data {}
set histoS_data  {}; set netvarS_data  {}; set tapeS_data {}
set histoB_data  {}; set spyM_data    {}

set info ""

proc init-parameters {} {
    global users_list edit frametitle ERROR

    set frametitle "Back End Setup (Display)"
    set edit 0
    set user [whoami]
    foreach authorized_user $users_list {
	if {$authorized_user == $user} then {
	   set frametitle "Back End Setup (Edit)"
    	   set edit 1
	   break
	}
    }
}


#####################  FRAMES  #############################

proc make-frame {} {
   global env edit
   set label_modules ""

   if {$edit} then {set label_modules "Modify"; set inactive F} \
   	        else {set label_modules "Display"; set inactive T}

   :frame [self frame-name]  :label [self frame-title] \
	:show-footer T \
      :icon-image "@$env(ICONHOME)/euroball" \
	:icon-name [self icon-title] :resize F

        :panel ACTIONS1  :layout T :padx 15 :pady 5
   	   :layout H; :col-gap 0
 	   :button QUIT    :w 15 :bold T
           :hskip 40
 	   :button INSTALL :w 15 :bold T :inactive $inactive
 	   :button CANCEL  :w 15 :bold T :inactive $inactive
           :hskip 40
	   :button STAT  :label "Statistics..." :w 15 :bold T

        :panel DISPLAY :layout T :padx 10 :pady 5
           :layout H; :col-gap 10
  	   :text USER :label "User : " :bold T :w 10  :value " [whoami]" :deaf T
  	   :text HOST :label "Host : " :bold T :w 10  :value " [hostname]" :deaf T
	   :message PATH_M :label "Paths :"
          :col-gap 0
  	   :text PATH1  :label "" :w 20 :value " $env(EB_ETC)"    :deaf T
  	   :text PATH2  :label "" :w 20 :value " $env(EB_CONFIG)" :deaf T

        :panel FARM :layout T :padx 10 :pady 5 :ipady 5 :relief R
           :layout V
           :message AFM :label "Configuration:- Event Processor Farm" :bold T
  	   :text EV_FARM_HOSTS  :label "Hosts    "  :w 50  :valuex 30c \
				:deaf T :shifters T
           :message SFM :label "Configuration:- Spy Processor Farm" \
           		:bold T :x 0
  	   :text SPY_FARM_HOSTS :label "Hosts    "  :w 50  :valuex 30c \
				:deaf T :shifters T

        :panel MODULES1 :layout T :padx 10 :pady 5
   	   :layout H; :col-gap 10
	   :button EV_FARM   :label "Event Processors..."    :w 20
	   :button EV_NEORC  :label "Event NEO Resources..." :w 20 :inactive T
	   :button SPY_FARM  :label "Spy Processors..."      :w 20
	   :button SPY_NEORC :label "Spy NEO Resources..."   :w 20 :inactive T	   
	
        :panel MNGSERV :layout T :padx 10 :pady 5 :ipady 5 :relief R
           :layout H; :col-gap 0; :row-gap 2
           :message BRG_M    :label "Configuration:- Bridge" :bold T
           :next-row T; :hskip 10
           :message BRG_NAME :label "Histogrammer : " :w 20 :anchor nw
  	   :text BRG_HOST :label "Host   "   :w 15  :deaf T  :valuex 8c
  	   :text BRG_SERV :label "Server   " :w 20  :deaf T  :valuex 12c
           :next-row T
           :message MNG_M :label "Configuration:- Managers" :bold T
           :next-row T; :hskip 10
           :message MNG_NAME :label "Histogrammer : " :w 20 :anchor nw
  	   :text HM_HOST  :label "Host   "    :w 15  :deaf T  :valuex 8c
  	   :text HM_SERV  :label "Manager   " :w 20  :deaf T  :valuex 12c
           :next-row T; :hskip 10
           :message NM_NAME :label "Network Variables :" :w 20 :anchor nw
  	   :text NM_HOST :label "Host   "     :w 15  :deaf T  :valuex 8c
  	   :text NM_SERV :label "Manager   "  :w 20  :deaf T  :valuex 12c
           :next-row T; :hskip 10
           :message TM_NAME :label "Tape : " :w 20 :anchor nw
  	   :text TM_HOST :label "Host   "     :w 15  :deaf T  :valuex 8c
  	   :text TM_SERV :label "Manager   "  :w 20  :deaf T  :valuex 12c
           :next-row T; :hskip 10
           :message SPY_NAME :label "Spy : " :w 20 :anchor nw
  	   :text SPY_HOST :label "Host   "     :w 15  :deaf T  :valuex 8c
  	   :text SPY_SERV :label "Manager   "  :w 20  :deaf T  :valuex 12c
           :next-row T
           :message SERV_M  :label "Configuration:- Servers" :bold T 
           :next-row T; :hskip 10
           :message LOG_M :label "Logger : " :w 20 :anchor nw
  	   :text LOG_HOST :label "Host   "   :w 15  :deaf T   :valuex 8c
  	   :text LOG_SERV :label "Server   " :w 20  :deaf T   :valuex 12c
           :next-row T; :hskip 10
           :message HS_NAME :label "Histogrammer : "  :w 20 :anchor nw
  	   :text HS_HOSTS :label "Hosts   "  :w 50 :deaf T  :shifters T :valuex 8c
           :next-row T
  	   :text HS_SERVS :label "Servers "  :w 70 :deaf T  :shifters T :valuex 25c
           :next-row T; :hskip 10
           :message NS_NAME :label "Network Variables : "  :w 20 :anchor nw
  	   :text NS_HOSTS :label "Server  "  :w 20  :deaf T :valuex 8c
           :next-row T; :hskip 10
           :message TS_NAME :label "Tape : "  :w 20 :anchor nw
  	   :text TS_HOSTS :label "Hosts   "  :w 50  :deaf T  :shifters T :valuex 8c
           :next-row T
  	   :text TS_SERVS :label "Servers  "  :w 70  :deaf T  :shifters T :valuex 25c
	
        :panel MODULES2 :layout T :padx 10 :pady 5
   	   :layout H; :col-gap 10
	   :button LOG       :label "Logger..." 	   :w 15
	   :button HISTO     :label "Histogrammer..."	   :w 15
	   :button NETVAR    :label "Network Variables..." :w 20
	   :button TAPE      :label "Tape... "		   :w 15
	   :button SPY       :label "Spy..."		   :w 15
          
        :panel MESS :layout T :padx 5
        if {$edit} then {
           :layout H; :row-gap 5
           :message M_CLEAR  :label "Messages" :bold T
	     :button  CLEAR :label "Clear Messages"
           :next-row T
           :galley MESSAGES :rows 6 :cols 100 :deaf T
	}

   :show T
}


#####################  PROC  #############################


proc read-files {} {
    global env evFarm_data spyFarm_data log_data 
    global histoM_data netvarM_data tapeM_data spyM_data
    global histoB_data histoS_data netvarS_data tapeS_data

    set evFarm_data    [read-file [file join $env(EB_ETC) evFarm.conf]]
    set spyFarm_data   [read-file [file join $env(EB_ETC) spyFarm.conf]]
    set log_data       [read-file [file join $env(EB_ETC) log.conf]]
    set histoB_data    [read-file [file join $env(EB_ETC) histoB.conf]]

    set histoM_data    [read-file [file join $env(EB_ETC) histoM.conf]]
    set netvarM_data   [read-file [file join $env(EB_ETC) netvarM.conf]]
    set tapeM_data     [read-file [file join $env(EB_ETC) tapeM.conf]]
    set spyM_data      [read-file [file join $env(EB_ETC) spyM.conf]]

    set histoS_data    [read-file [file join $env(EB_ETC) histoS.conf]]
    set netvarS_data   [read-file [file join $env(EB_ETC) netvarS.conf]]
    set tapeS_data     [read-file [file join $env(EB_ETC) tapeS.conf]]
}


proc display-files {} {
   global evFarm_data spyFarm_data log_data
   global histoM_data netvarM_data tapeM_data spyM_data
   global histoB_data histoS_data netvarS_data tapeS_data

   display-evFarm_conf    $evFarm_data
   display-spyFarm_conf   $spyFarm_data
   display-log_conf       $log_data
   display-histoB_conf    $histoB_data

   display-histoM_conf    $histoM_data
   display-netvarM_conf   $netvarM_data
   display-tapeM_conf     $tapeM_data
   display-spyM_conf      $spyM_data

   display-histoS_conf    $histoS_data
   display-netvarS_conf   $netvarS_data
   display-tapeS_conf     $tapeS_data
}

proc display-evFarm_conf {data} {
   set ll ""

   foreach item $data {
      if {$item != {}} {append ll "[first $item]   "}
   }
   :modify EV_FARM_HOSTS :value " $ll"
}

proc display-spyFarm_conf {data} {
   set ll ""

   foreach item $data {
      if {$item != {}} {append ll "[first $item]   "}
   }
   :modify SPY_FARM_HOSTS :value " $ll"
}

proc display-log_conf {data} {
   set host ""; set server ""

   foreach item $data {
      if {$item != {}} {
         set host   [first $item]
         set server [second $item]
      }
   }
   :modify LOG_HOST :value " $host"
   :modify LOG_SERV :value " $server"
}

proc display-histoB_conf {data} {
   set host ""; set server ""

   foreach item $data {
      if {$item != {}} {
         set host   [first $item]
         set server [second $item]
      }
   }
   :modify BRG_HOST :value " $host"
   :modify BRG_SERV :value " $server"
}
   
proc display-histoM_conf {data} {
   set host ""; set server ""

   foreach r $data {
      if {$r != {}} {
         set host   [first $r]
         set server [second $r]
      }
   }
   :modify HM_HOST  :value " $host"
   :modify HM_SERV  :value " $server"
}

proc display-histoS_conf {data} {
   set lh ""; set ls ""
   
   foreach item $data {
      if {$item != {}} {
         set host   [first $item];  append lh "$host   "
         set server [second $item]; append ls "$server   "
      }
   }
   :modify HS_HOSTS  :value " $lh"
   :modify HS_SERVS  :value " $ls"
}


proc display-netvarM_conf {data} {
   set host ""; set server ""

   foreach r $data {
      if {$r != {}} {
         set host   [first $r]
         set server [second $r]
      }
   }
   :modify NM_HOST  :value " $host"
   :modify NM_SERV  :value " $server"
}

proc display-netvarS_conf {data} {
   set lh ""; set ls ""
   
   foreach item $data {
      if {$item != {}} {
         set host [first $item];  append lh "$host   "
      }
   }
   :modify NS_HOSTS  :value " $lh"
}

proc display-tapeM_conf {data} {
   set host ""; set server ""

   foreach r $data {
      if {$r != {}} {
         set host   [first $r]
         set server [second $r]
      }
   }
   :modify TM_HOST  :value " $host"
   :modify TM_SERV  :value " $server"
}

proc display-tapeS_conf {data} {
   set lh ""; set ls ""
   
   foreach item $data {
      if {$item != {}} {
         set host   [first $item];  append lh "$host   "
         set server [second $item]; append ls "$server   "
      }
   }
   :modify TS_HOSTS  :value " $lh"
   :modify TS_SERVS  :value " $ls"
}

proc display-spyM_conf {data} {
   set host ""; set server ""

   foreach r $data {
      if {$r != {}} {
         set host   [first $r]
         set server [second $r]
      }
   }
   :modify SPY_HOST  :value " $host"
   :modify SPY_SERV  :value " $server"
}

#---------- Proc called extern modules -------------------------

proc update-evFarm_conf {args} {
   global  evFarm_data modify 
   set modify 1
   set evFarm_data $args
   display-evFarm_conf $args
   set-footer "Install (needed)..."
}

proc cancel-evFarm_conf {} {
   global  evFarm_data  env open_frame_evFarm

   set evFarm_data     [read-file [file join $env(EB_ETC) evFarm.conf]]
   display-evFarm_conf $evFarm_data
   if {$open_frame_evFarm} {click-evFarm}
}

proc update-spyFarm_conf {args} {
   global  spyFarm_data modify 
   set modify 1
   set spyFarm_data $args
   display-spyFarm_conf $args
   set-footer "Install (needed)..."
}

proc cancel-spyFarm_conf {} {
   global  spyFarm_data  env open_frame_spyFarm

   set spyFarm_data     [read-file [file join $env(EB_ETC) spyFarm.conf]]
   display-spyFarm_conf $spyFarm_data
   if {$open_frame_spyFarm} {click-spyFarm}
}

proc update-log_conf {args} {
   global  log_data modify 
   set modify 1
   set log_data		$args
   display-log_conf 	$args
   set-footer "Install (needed)..."
}

proc cancel-log_conf {} {
   global  log_data env open_frame_log

   set log_data     [read-file [file join $env(EB_ETC) log.conf]]
   display-log_conf $log_data
   if {$open_frame_log} {click-log}
}

proc update-histoB_conf {args} {
   global  histoB_data modify 
   set modify 1
   set histoB_data      $args
   display-histoB_conf 	$args
   set-footer "Install (needed)..."
}

proc cancel-histoB_conf {} {
   global  histoB_data env open_frame_histoB

   set histoB_data     [file join [read-file $env(EB_ETC) histoB.conf]]
   display-histoB_conf $histoB_data
   if {$open_frame_histoB} {click-histo}
}
   
proc update-histoM_conf {args} {
   global  histoM_data modify 
   set modify 1
   set histoM_data	$args
   display-histoM_conf  $args
   set-footer "Install (needed)..."
}

proc cancel-histoM_conf {} {
   global  histoM_data env open_frame_histo

   set histoM_data     [file join [read-file $env(EB_ETC) histoM.conf]]
   display-histoM_conf $histoM_data
   if {$open_frame_histo} {click-histo}
}

proc update-netvarM_conf {args} {
   global  netvarM_data modify 
   set modify 1
   set netvarM_data	$args
   display-netvarM_conf $args
   set-footer "Install (needed)..."
}

proc cancel-netvarM_conf {} {
   global  netvarM_data env open_frame_netvar

   set netvarM_data     [read-file [file join $env(EB_ETC) netvarM.conf]]
   display-netvarM_conf $netvarM_data
   if {$open_frame_netvar} {click-netvar}
}

proc update-tapeM_conf {args} {
   global  tapeM_data modify 
   set modify 1
   set tapeM_data    	$args
   display-tapeM_conf 	$args
   set-footer "Install (needed)..."
}

proc cancel-tapeM_conf {} {
   global  tapeM_data env open_frame_tape

   set tapeM_data     [read-file [file join $env(EB_ETC) tapeM.conf]]
   display-tapeM_conf $tapeM_data
   if {$open_frame_tape} {click-tape}
}

proc update-spyM_conf {args} {
   global  spyM_data modify 
   set modify 1
   set spyM_data    	$args
   display-spyM_conf 	$args
   set-footer "Install (needed)..."
}

proc cancel-spy_conf {} {
   global  spy_data env open_frame_spy

   set spy_data     [read-file [file join $env(EB_ETC) spy.conf]]
   display-spy_conf $spy_data
   if {$open_frame_spy} {click-spy}
}

proc update-histoS_conf  {args} {
   global  histoS_data modify 
   set modify 1
   set histoS_data 	$args
   display-histoS_conf 	$args
   set-footer "Install (needed)..."
}

proc cancel-histoS_conf {} {
   global  histoS_data env open_frame_histo

   set histoS_data     [read-file [file join $env(EB_ETC) histoS.conf]]
   display-histoS_conf $histoS_data
   if {$open_frame_histo} {click-histo}
}

proc update-netvarS_conf {args} {
   global  netvarS_data modify 
   set modify 1
   set netvarS_data 	$args
   display-netvarS_conf $args
   set-footer "Install (needed)..."
}

proc cancel-netvarS_conf {} {
   global  netvarS_data env open_frame_netvar

   set netvarS_data     [file join [read-file $env(EB_ETC) netvarS.conf]]
   display-netvarS_conf $netvarS_data
   if {$open_frame_netvar} {click-netvar}
}

proc update-tapeS_conf  {args} {
   global  tapeS_data modify 
   set modify 1
   set tapeS_data 	$args
   display-tapeS_conf 	$args
   set-footer "Install (needed)..."
}
   
proc cancel-tapeS_conf {} {
   global tapeS_data env open_frame_tape

   set tapeS_data     [file join [read-file $env(EB_ETC) tapeS.conf]]
   display-tapeS_conf $tapeS_data
   if {$open_frame_tape} {click-tape}
}

proc quit-evFarm {args} {
   global open_frame_evFarm
   set open_frame_evFarm 0
}
   
proc quit-spyFarm {args} {
   global open_frame_spyFarm
   set open_frame_spyFarm 0
}
   
proc quit-log    {args} {
   global open_frame_log
   set open_frame_log 0
}
   
proc quit-histo  {args} {
   global open_frame_histo
   set open_frame_histo 0
}
   
proc quit-netvar {args} {
   global open_frame_netvar
   set open_frame_netvar 0
}
   
proc quit-tape   {args} {
   global open_frame_tape
   set open_frame_tape 0
}
   
proc quit-spy    {args} {
   global open_frame_spy
   set open_frame_spy 0
}


#####################  CLICK  #############################

proc click {arg} {
   global debug 

   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]

   if {$c==":quit"} then {click-quit $f; return}

   switch  $w {
      EV_FARM   {click-evFarm}
      SPY_FARM	{click-spyFarm}
      LOG     	{click-log}

      HISTO 	{click-histo}
      NETVAR 	{click-netvar}
      TAPE   	{click-tape}
      SPY   	{click-spy}

      INSTALL 	{click-install}
      STAT  	{click-statistics}
      CANCEL 	{click-cancel}
      CLEAR     {:modify MESSAGES :empty T}

      QUIT   	{click-quit $f}

      default 	{puts stdout $arg}
   }
}

proc click-evFarm {} {
    global edit evFarm_data open_frame_evFarm cancel mytaskfirstname
    global info
    
    set info [inform $mytaskfirstname-ef start $edit $cancel [list $evFarm_data]]
    set open_frame_evFarm 1
}

proc click-spyFarm {} {
    global edit spyFarm_data open_frame_spyFarm cancel mytaskfirstname
    global info
    
    set info [inform $mytaskfirstname-sf start $edit $cancel [list $spyFarm_data]]
    set open_frame_spyFarm 1
}

proc click-log {} {
    global edit log_data open_frame_log cancel mytaskfirstname
    global info

    set info [inform $mytaskfirstname-lg start $edit $cancel [list $log_data]]
    set open_frame_log 1
}

proc click-histo {} {
    global edit histoM_data histoS_data histoB_data  open_frame_histo 
    global cancel mytaskfirstname 
    global info

    set info [inform $mytaskfirstname-hi start $edit $cancel [list $histoM_data $histoS_data $histoB_data]]
    set open_frame_histo 1
}

proc click-netvar {} {
    global edit netvarM_data netvarS_data evFarm_data open_frame_netvar
    global cancel mytaskfirstname 
    global info

    set info [inform $mytaskfirstname-nv start $edit $cancel [list $netvarM_data $netvarS_data $evFarm_data]] 
    set open_frame_netvar 1
}

proc click-tape {} {
    global edit tapeM_data tapeS_data open_frame_tape cancel
    global  mytaskfirstname 
    global info

    set info [inform $mytaskfirstname-tp start $edit $cancel [list $tapeM_data $tapeS_data]]
    set open_frame_tape 1
}

proc click-spy {} {
    global edit spyM_data open_frame_spy cancel mytaskfirstname
    global info

    set info [inform $mytaskfirstname-spy start $edit $cancel [list $spyM_data]]
    set open_frame_spy 1
}

proc click-statistics {} {
    global hosts_list edit frame_name mytaskfirstname
    global info

    set-busy
    set info [inform $mytaskfirstname-stat start $edit [list $hosts_list]]
    clear-busy
}

proc click-cancel {} {
    global open_frame_evFarm open_frame_spyFarm open_frame_log 
    global open_frame_histo open_frame_netvar open_frame_tape 
    global open_frame_spy cancel modify 

    if {!$modify} then {return}

    set s [midas-confirmation "Are you sure you want to cancel all modifications?"]
    if {$s} then {
       set cancel 1
       read-files
       display-files
       if {$open_frame_evFarm}    {click-evFarm}
       if {$open_frame_spyFarm}   {click-spyFarm}
       if {$open_frame_log}       {click-log}
       if {$open_frame_histo}     {click-histo}
       if {$open_frame_netvar}    {click-netvar}
       if {$open_frame_tape}      {click-tape}
       if {$open_frame_spy}       {click-spy}
       set cancel 0
       set modify  0
       clear-footer
   }
}

proc click-install {} {
    global modify mytaskfirstname 

    if {!$modify} {return}

    set i [midas-confirmation  \
	  "This operation will  \n\
	   MODIFY the configuration files,\n\
	   KILL any existing servers,\n\
	   PUT (start) the new servers and \n\
	   COPY the configuration files to all machines of the farm... \n\n \
	   Do you wish to continue?"]
    if {$i} then  {
       set-busy-watch "Installing: Please wait..."
       set length [expr [string length $mytaskfirstname] + 1]
       foreach task [Get_Task_Names] {
          if {[string first $mytaskfirstname $task] > -1} then {
             set choice [string range $task $length end]
             switch $choice {
		"ef"  {set mod "Event Processors Farm"}
		"sf"  {set mod "Spy Processors Farm"}
		"hi"  {set mod "Histogrammer"}
		"lg"  {set mod "Logger"}
		"nv"  {set mod "Network Variables"}
		"spy" {set mod "Spy"}
		"tp"  {set mod "Tape"}
      		default {set mod ""}
             }
             if {$mod != ""} {
                set-footer "Installing in module \"$mod\" : Please wait..."
                :modify MESSAGES :strings "[date]: Installing in module \"$mod\"\n"
	        set z [catch {send $task install} m]
                if {$z != 0} then {
                   midas-warning "Installation in module \"$mod\" failed\n$m"
                   :modify MESSAGES :strings "[date]: Installation in module \"$mod\" failed\n$m\n"
                } else {
                   :modify MESSAGES :strings "[date]: Installation in module \"$mod\" successful\n"
                   if {$mod == "Event Processors Farm"} then {inform ec set-config}
                }
  	     }
         }
         set modify 0
      }
      clear-busy-watch
   }
}

proc click-quit {f} {
    global modify mytaskfirstname

    if {$modify} then {
       set q [midas-confirmation "Configuration has not been installed!\n\n\Install before exiting?"]
       if {$q} then {click-install}
    }

    foreach task [Get_Task_Names] {
      if {[string first $mytaskfirstname $task] > -1} then {      
         catch {send $task finish}
      }
    }
    destroy-frame $f
}


#####################  START  #############################

proc start {} {
   global started

   init-environment
   init-parameters
   if {$started != 0} then {
      open-frame
   } else {
      make-frame
      set started 1
   }
   centre-frame
   read-files
   display-files
}

proc install {} {return}
