#
#    common.beSetup.tcl
#
#    procedures used to Back End Setup

set log_file ""
set edit  0; set modify 0; set add  0; set cancel 0
set line_index 0; set line_index_list  {}

#    following 7 items are setup via do_configure
set work_host ""
set users_list {root}
set hosts_list {}
set fhosts_list {}
set ports_list_hi {}
set ports_list_tp {}
set ports_list_spy {}



proc :panel-dialog {size b1 cmd1 b2 cmd2} {
  
   set label1 [string toupper [string index $b1 0]][string tolower [string range $b1 1 end]]
   set label2 [string toupper [string index $b2 0]][string tolower [string range $b2 1 end]]

   :panel DIALOG :layout B :padx 10 :expand no :fill none
     set w [winfo parent [:path DIALOG]]
       :layout H; :col-gap [expr 2 * $size]

       :hskip $size
       :button DIALOG1 :label  $label1 :w 6 :h 3         :command $cmd1
       :button DIALOG2 :label  $label2 :w 6 :h 3 :hlt 2  :command $cmd2
}
 

proc do_configure {} {
   global env
   global work_host users_list
   global hosts_list fhosts_list ports_list_hi ports_list_tp ports_list_spy

   set file [file join $env(EB_CONFIG) MIDAS]
   set z [catch {open $file r} f]
#   if {$z != 0} then {midas-warning "Unable to read configuration file $file\n$f\n\n\
#      This must be corrected before you can continue"; return}
   if {$z != 0} then {puts stderr "Unable to read configuration file $file\n$f\n\n\
      This must be corrected before you can continue"; return}
   set config [split [read $f] \n]
   close $f
   set hosts_list {}
   set fhosts_list {}
   foreach item $config {
      set l [string trimleft [string trimright $item]]
      if {$l == ""} then continue
      if {[string range $l 0 0] == "#"} then continue
      set command [first $l]
      switch $command {
         host {
            lappend hosts_list [second $l]
            lappend fhosts_list [third $l]
         }
         serverhost {
            set work_host [second $l]
         }
         privusers {
            set users_list [lreplace $l 0 0]
         }
         histoports {
            set ports_list_hi [lreplace $l 0 0]
         }
         tapeports {
            set ports_list_tp [lreplace $l 0 0]
         }
         spyports {
            set ports_list_spy [lreplace $l 0 0]
         }
         default {}
      }
   }
}

proc insert-line-list {} {
   global line_index_list line_index

   set i [lsearch -exact $line_index_list $line_index]
   if {$i >= 0} return
   lappend line_index_list $line_index
}

proc delete-line-list {} {
   global line_index_list line_index

   set line_index_list [ldelete $line_index_list $line_index]
}

proc distribution {f} {
   global  hosts_list work_host

   set local_host [hostname]
   if {$local_host != $work_host} {rcp $f $local_host $f}

   foreach host $hosts_list {
      if {$host != $local_host} {rcp $f $host $f}
   }
}

#    execute the configuration now

init-environment
do_configure
