
#    name of the MIDAS server to use to access MPX modules

set MUXserver camac
set MUXrouting 1

#    names of the MPX modules connected to each inspection line
#      note - camac module creation is in /MIDAS/config/camac

set MPXmodule(AI1) Mpx1
set MPXmodule(AI2) Mpx2
set MPXmodule(DI1) Mpx3
set MPXmodule(DI2) Mpx4

#    routing table
#    set routing(vxin) m
#    to connect inspection line for crate vxin write m to the MPX module

set MPXrouting(vxi1) 0
set MPXrouting(vxi2) 1
set MPXrouting(vxi3) 2
set MPXrouting(vxi4) 3
set MPXrouting(vxi5) 4
set MPXrouting(vxi6) 5
set MPXrouting(vxi7) 6
set MPXrouting(vxi8) 7
set MPXrouting(vxi9) 8
set MPXrouting(vxi0) 9

set MPXrouting(nw) 10

proc connect-inspection {line crate} {
   global MUXserver MUXrouting MPXmodule MPXrouting

#    check option present and enabled

   if {$MUXserver == "" || $MUXrouting == 0} then {return}

#   create register name and value to write

   set register /$MUXserver/[set MPXmodule($line)].data
   set value $MPXrouting($crate)

#   execute

    catch {EG "register :name '$register' :value '$value'"}
}



#    The following line should be removed to enable the multiplexor
#set MUXrouting 0
