# ebdiag.tcl---Euroball diagnostic tcl scripts

#   April 11th  VP

set frame EBDIAG
set frametitle "Euroball diagnostic TCL Scripts"
set icontitle "EbDiags"

set directory "$env(MIDASBASE)/euroball/tcl/ebdiag"
set selection {}

proc make-frame {} {
   global env

    :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-name "[self icon-title]" :resize F

      :panel P1 :layout T :padx 10 :pady 10
         :layout H; :row-gap 0

         :text DIRECTORY :label "Directory:" :w 60 :shifters T
         :button UP
         :button DOWN

      :panel P2 :layout T :padx 10
         :list DIRECTORYLIST :exclusive T :rows 10 :cols 80

      :panel P3 :layout T :padx 10 :pady 10
         :layout H; :col-gap 10
         :button REDISPLAY
         :button EXECUTE
         :button SHOW
         :hskip 80
         :button HELP   :command click-help
      
      :show T
} 

proc click-execute {} {
   global directorylist selection directory
   if {[llength $selection]==0} then {
      set-footer "no script selected!!!"
      return
   }
   set target [lindex $directorylist $selection]
   if {[string range $target 0 0] == "d"} then {
      set-footer "can't execute a directory!!!"
      return
   }
   set file [last $target]
   set-footer "executing $directory/$file..."
   set z [catch {source  $directory/$file} m]
   if {$z!=0} then {set-footer $m} else {clear-footer}
}

proc click-directory name {
   global directory
   set directory $name
   click-redisplay
}

proc click-directorylist {v i} {
   global selection 
   set selection $i        
}

proc click-redisplay {} {
   global directory selection
   :modify DIRECTORY :value "$directory"
   read-directory $directory
   paint-directory $directory
   set selection {}
}

proc click-up {} {
  global directory
  set directory [directory-up $directory]
  click-redisplay
}

proc click-down {} {
  global directory selection
  set directory [directory-down $directory $selection]
  click-redisplay
}

proc click-show {} {
   global directorylist selection directory
   if {[llength $selection]==0} then {
      set-footer "no file selected!!!"
      return
   }
   set target [lindex $directorylist $selection]
   if {[string range $target 0 0] == "d"} then {
      set-footer "can't show a directory!!!"
      return
   }
   midas-show-file $directory/[last $target]
}


