
#    Script file to format a EventbyEvent formatted data block

set datafile /tmp/spydump[pid]
set farmcpu eb03
set dumpbytes 2048
set dumpwords 512

clear-footer

proc format_the_spydumpshot {} {
  upvar 1 datafile datafile
  upvar 1 dumpbytes dumpbytes
  upvar 1 dumpwords dumpwords
  upvar 1 farmcpu farmcpu
  global spydumpdata

   set frame "spydump"
   :frame [self frame-name].$frame :label "Formatted EventbyEvent Data Snapshot" :transient T

   :font local text n :fmly courier

        :galley G :rows 50 :cols 80 :deaf T :strings ""
        :show T
  
    if {[exec hostname] != "eb09"} then {
       :modify G :strings "Sending request to eb09 to spy on $farmcpu\n"
    } else {
        :modify G :strings "Sending request to spy on $farmcpu\n"
    }
        update
    if {[exec hostname] != "eb09"} then {
        set reply [exec rsh eb09 /MIDAS/bin/euroball-spydump f$farmcpu $datafile]
    } else {
        set reply [exec /MIDAS/bin/euroball-spydump f$farmcpu $datafile]
    }
        :modify G :strings "$reply\n"
    if {[exec hostname] != "eb09"} then {
        :modify G :strings "Fetching file from eb09\n"
        update
        set reply [exec rcp eb09:$datafile $datafile]
        :modify G :strings "$reply\n"
    }

        :modify G :strings "Formatting the EventbyEvent data\n"
        update
        set spydumpdata [exec /usr/bin/od -xv -N $dumpbytes $datafile]

        set dump ""
        set count 0
        set inheader 1
        for {set i 1} {$i <= $dumpwords} {incr i} {
           incr count
           set word [lindex $spydumpdata $i]
           if {$word == "fff0"} then {
             :modify G :strings "$dump\n"
#             if {$inheader == 0} then {format_an_event $dump}
             :modify G :strings "\n"
             set dump ""
             set inheader 0
           }
           append dump "$word "
           if {$count == 8} {incr i; set count 0}
        }
        :modify G :strings $dump

   :modify G :see 0
   clear-footer
}

global detectorfamily

set detectorfamily(32)  "header"
set detectorfamily(65)  "Cluster"
set detectorfamily(66)  "Clover"
set detectorfamily(3)   "Tapered"
set detectorfamily(100)  "Cluster (full)"
set detectorfamily(5)   "Ancillary (VXI)"
set detectorfamily(6)   "Ancillary (fera)"
set detectorfamily(7)   "Master Trigger"
set detectorfamily(8)   "VRE"

proc format_an_event the_event {
   upvar #0 detectorfamily families
   set word [lindex $the_event 0]
   :modify G :strings "Start Event Token 0x$word  - event format type [expr 0x$word & 15]\n"
   set word [lindex $the_event 1]
   :modify G :strings "Event Length [expr 0x$word] bytes\n"
   set i 2
   set word [lindex $the_event $i]
   set id [expr 0x$word & 0x1ff]
   set family [expr 0x$word >> 9]
   :modify G :strings "Detector Family $families($family)  Detector id $id\n"
}

#    and execute the script

format_the_spydumpshot
