
#    this file is run at global level to create the final neo++ program source

     NEO "//    NEO++ program generated [date]\n\n\n\n"

     NEO "#include \"neo++.h\""
     NEO "#include <signal.h>"
     NEO "#include <fstream.h>"

     NEO ""

#    here copy in the generated event.h declarations

   foreach c $VXICardChoice {
      if {$VXICardInuse([lowercase $c]) == 1} then {NEO "$eventh([lowercase $c])"}
   }

   if {$NeoOptions(tote) == 1} then {
     NEO "format (TotalE)"
     NEO "    item   Energy;"
     NEO "    item   EvNumLSW;"
     NEO "    item   EvNumMSW;"
     NEO "end_format"
     NEO ""
     NEO "Detector<TotalE,TOTAL_GE> total_e;"
   }
     
     NEO "#define TRUE 1"
     NEO "#define FALSE 0"

     NEO ""

     NEO "eb_main {"

#    define require variables
     NEO ""
     NEO "   int j, jj;"
     NEO "   long int tot_20MeV;"
     NEO "   long int TotalBgoEnergy;"
     NEO "   int BgoBallEnergy;"
     NEO "   int E4, E20, ft, co;"
     NEO "   int keyDet=0, keySpec=0, temp=0, valid;"
     NEO "   unsigned short MTEvNumLSW, MTEvNumMSW;"
     NEO "   int anti_compton, pile_up;"

     NEO "   int nb_det;"
     NEO "   char adc\[30\];"
     NEO "   long int BgoEnergy;"
     NEO "   int all_ac, one_ac;"
     NEO "   int foldBgoBall;"

#    insert code setup for gain matching option

  if {$NeoOptions(gm) == 1} then {

     NEO "// file containing coefficients for calibration "
     NEO "// one line per histogram "
     NEO "// each line contains 2 numbers A & B to compute a new histogram Ax+B "
     NEO "   ifstream calFile(\"./cal_coeffs_4MeV.dat\",ios::in|ios::nocreate);"
     NEO "   ifstream calFile2(\"./cal_coeffs_20MeV.dat\",ios::in|ios::nocreate);"

     NEO "   if (!calFile) \{"
     NEO "     cerr << \"File ./cal_coeffs_4MeV.dat not found\" << endl;"
     NEO "     exit (1);"
     NEO "   \};"
     NEO ""

     NEO "   if (!calFile2) \{"
     NEO "     cerr << \"File ./cal_coeffs_20MeV.dat not found\" << endl;"
     NEO "     exit (1);"
     NEO "   \};"
     NEO ""

     NEO "   // to store the coefficients"
     NEO "   float coeff_a\[245\];"
     NEO "   float coeff_b\[245\];"
     NEO "   float coeff20_a\[245\];"
     NEO "   float coeff20_b\[245\];"
     NEO ""

     NEO "   // reading the coeff 4MeV"
     NEO "   for (j=0; j < 245; j++) \{"
     NEO "      calFile >> coeff_a\[j\];"
     NEO "      cout << \"A\[\" << j << \"]=\" << coeff_a\[j\] ;"
     NEO "      calFile >> coeff_b\[j\];"
     NEO "      cout << \"B\[\" << j << \"\]=\" << coeff_b\[j\] << \" \" ;"
     NEO "      calFile >> nb_det;"
     NEO "      cout << nb_det ;"
     NEO "      calFile >> adc;"
     NEO "      cout << adc << endl;"
     NEO "   \};"
     NEO ""

     NEO "   // reading the coeff 20MeV"
     NEO "   for (j=0; j < 245; j++) \{"
     NEO "      calFile2 >> coeff20_a\[j\];"
     NEO "      cout << \"A20\[\" << j << \"\]=\" << coeff20_a\[j\] ;"
     NEO "      calFile2 >> coeff20_b\[j\];"
     NEO "      cout << \"B20\[\" << j << \"\]=\" << coeff20_b\[j\] << \" \" ;"
     NEO "      calFile2 >> nb_det;"
     NEO "      cout << nb_det ;"
     NEO "      calFile2 >> adc;"
     NEO "      cout << adc << endl;"
     NEO "   \};"
     NEO ""
     NEO "    int rnd =1, temp_gm =0;"
     NEO "    int tmp_gm4\[7\];"
     NEO "    int tmp_gm20\[7\];"

  }

#    create all required software histograms

     NEO "    Hist1D    Astat(256,\"Astat\");"
  if {$NeoOptions(totege) == 1} then {
     NEO "    Hist1D    TotGe(8192,\"TotalE_80Mev\");"
  }
  if {$NeoOptions(totebgo) == 1} then {
     NEO "    Hist1D    TotBgo(8192,\"TotalBGO_80Mev\");"
  }
  if {$NeoOptions(totebgoball) == 1} then {
     NEO "    Hist1D    TotBgoBall(8192,\"TotalBGOball_80Mev\");"
  }
  if {$NeoOptions(tote) == 1} then {
     NEO "    Hist1D    TotEnergy(8192,\"TotalEnergy_80Mev\");"
  }

   foreach c $VXICardChoice {
      if {$VXICardInuse([lowercase $c]) == 1} then {NEO "    $histh([lowercase $c])"}
   }

     NEO ""

#    some initialisation

  if {$NeoOptions(tape) == 1} then {
     NEO "  Tape tape (1,32768);"
  }
  for {set i 1} {$i <= $NeoOptions(spystrms)} {incr i} {
     NEO "  Spy spi[set i]($i,1.0, 32768);"
  }
     NEO "  Event event;"
     NEO "  event.setVerboseOff();"
     NEO ""
     NEO "  const FLUSH = 30000;"
     NEO "  int flush=0;"
     NEO "  int good;"
     NEO ""

#    now starts the main loop

     NEO "  for(;;event.next()) \{         //   loop for next event"
     NEO ""
     NEO "    try \{                // process next event"
     NEO ""
     NEO "      tot_20MeV=0;"
     NEO "      TotalBgoEnergy=0;"
     NEO "      BgoBallEnergy=0;"
     NEO "      MTEvNumLSW=0;"
     NEO "      MTEvNumMSW=0;"
     NEO ""
     NEO "      if (flush++ == FLUSH ) \{ base_histo::flush(); flush = 0;\}  // flush software histograms to the server"
     NEO ""
     NEO "      Astat.inc(60);"
     NEO ""      
     NEO "      good = TRUE;"
     NEO "      if (event.isBad()) \{"
     NEO "	  for(int j=0; j < event.classification.size(); j++) \{"
     NEO "	     if(event.classification\[j\]) \{"
     NEO "                Astat.inc(j);"
     NEO " //   permit item missmatch (6); item missing (10); bad fragment map (16)"
     NEO "                if (j != 6 && j != 10 && j != 16) good = FALSE;"
     NEO "          \}"
     NEO "        \}"
     NEO "      \}"
     NEO "       if (good) {Astat.inc(61);} else {Astat.inc(62);}"
     NEO "       if (!good) goto next; //do not process bad events - especially do not write to tape!"

#    here copy in the generated neo++ for each card type

   foreach c $VXICardChoice {
      if {$VXICardInuse([lowercase $c]) == 1} then {NEO "$neo([lowercase $c])"}
   }

#    final tidy up for this event
      
     NEO "//    shift the total energies by 2 bits (factor of 4) so building a sum which fits into 8K channels"
  if {$NeoOptions(totege) == 1} then {
     NEO "      TotGe.inc(tot_20MeV >> 2 & 8191);"
  }
  if {$NeoOptions(totebgo) == 1} then {
     NEO "      TotBgo.inc(TotalBgoEnergy >> 2 & 8191);"
  }
  if {$NeoOptions(totebgoball) == 1} then {
     NEO "      TotBgoBall.inc(BgoBallEnergy >> 2 & 8191);"
  }
  if {$NeoOptions(tote) == 1} then {
     NEO "      TotEnergy.inc((tot_20MeV + BgoBallEnergy + TotalBgoEnergy) >> 2 & 8191);"
  }
     NEO ""

  if {$NeoOptions(tote) == 1} then {
     NEO "// to put the total energy on tape"
     NEO "      total_e.hasFired(0);      // to virtually activate the total energy pseudo detector"
     NEO "      total_e(0).Energy = (unsigned short)((tot_20MeV + BgoBallEnergy + TotalBgoEnergy) >> 2);"
     NEO "      total_e(0).EvNumLSW = MTEvNumLSW;"
     NEO "      total_e(0).EvNumMSW = MTEvNumMSW;"
  }
     NEO ""
     NEO "   \}"
     NEO ""
     NEO "    catch (RWxmsg & x) \{ cerr<<x.why()<<endl; \}"
     NEO "    catch (xmsg & x)  \{ cerr<<x.why()<<endl; \}"
     NEO "    catch (char * x)  \{ cerr<<x<<endl; \}"
     NEO ""
     NEO "    Astat.inc(63);"
  if {$NeoOptions(tape) == 1} then {
     NEO "    tape << event;"
  }
  for {set i 1} {$i <= $NeoOptions(spystrms)} {incr i} {
     NEO "  spi$i << event;"
  }
     NEO ""
     NEO " next:   continue;"
     NEO "  \}"
     NEO "\}"



