#  nwall.defn.tcl

#    Called by task  vmecontrol

#    This permits the Neutron Wall electronics to be a "pseudo" VME module and appear in the 
#    VME module control window. The DA actions are in the nwall task script.


proc {Add_Neutron Wall_Module} {name server addressdata} {
   
   set pcibus  [first  [split $addressdata :]]
   set pcislot [second [split $addressdata :]]
   inform nwall define-configuration $server $pcibus $pcislot
   inform nwall define-module
}

proc {Neutron Wall_DAQ-reset} {args} {inform nwall autostart; inform nwall click-reset}
proc {Neutron Wall_DAQ-go}    {args} {inform nwall autostart; inform nwall click-go}
proc {Neutron Wall_DAQ-halt}  {args} {inform nwall autostart; inform nwall click-halt}
proc {Neutron Wall_DAQ-setup} {args} {inform nwall autostart; inform nwall click-setup}
proc {Neutron Wall_DAQ-flush} {args} {inform nwall autostart; inform nwall click-flush}

#   for parameter save/restore
set {Neutron Wall_registersavepatterns} {Gate_Select Gate_Width Gate_Delay}

