# Target control frame
# for Euroball Target position control -- CW
# modifications following physicists request June 15th -- CW
# rev. by CW on January 2000 17th

set started 0
set debug 0
set COMMENT ""
set TARGETPATH /MIDAS/target
set LOGFILEPATH /MIDAS/euroball/tmp
set directory ""
set commentfile ""
set frame TARGET
set frametitle "Target Control"
set icontitle "Target"
array set pattern [list {1} "" {2} "" {3} "" {4} "" {5} "" {6} ""]
array set field [list {1} "" {2} "" {3} "" {4} "" {5} "" {6} ""]


global field
global pattern


proc make-frame {} {
  
  :frame [self frame-name] :label "[self frame-title]" :show-footer T  \
     :icon-name "[self icon-title]" :resize F
     
  :panel P :layout L :padx 10 :pady 10
        :layout V; :row-gap 15 

  :message    M11   :label "Set position" :bold T
 # :hskip 20

  :checkbox   C11   :label "1" :value 0 :w 20 :h 20
 # :hskip 15

  :checkbox   C12   :label "2" :value 0 :w 20 :h 20
 # :hskip 15  
  
  :checkbox   C13   :label "3" :value 0 :w 20 :h 20
 # :hskip 15
 
  :checkbox   C14   :label "4" :value 0 :w 20 :h 20
 # :hskip 15

  :checkbox   C15   :label "5" :value 0 :w 20 :h 20
 # :hskip 15

  :checkbox   C16   :label "6" :value 0 :w 20 :h 20



  :panel P1 :layout R :padx 10 :pady 10 
      :layout V
      :row-gap 20
      :message M1 :label "User Comments" :bold T
      foreach i {1 2 3 4 5 6 } {
        :text POSITION$i   :label $i :w 50 :h 100 :command click-comment :valuex 5c
	
      }

  
  :panel B1 :layout B :padx 10 :after FOOTER 
       :layout H; :col-gap 10
  :hskip 5
  :button GETSTATUS :label "Get Status"
  :hskip 5
  :button SETTARGET :label "Set Position"
  :hskip 5
  :button REDISPLAY :label "Redisplay"
  :hskip 5
  :button CLEARFIELDS :label "Clear Fields"
  :hskip 5
  :button DELETESAVEFILE :label "Delete File"
  :show T

  
}



proc click-set {i}  {
     global TARGETPATH
       set pos $i
       set-footer "Target positionning ..."
       if {$pos == 0} then {
              midas-warning "Please select a position!!\n"
              return
       }
       set-footer "Target positionning ..."
       set z [catch {exec rsh eb56 $TARGETPATH/bin/target $pos} status]
       if {$z != 0} then {
                  midas-warning "Error: command target failed"\
                  puts stdout "command target returned value: $status"
                  return
       }
       after 10000
       set-footer "You are now working in position $pos"
       insert-log "You are now working with target in position $pos"
       return
}




proc click-get {} {
      global TARGETPATH


        foreach i {C11 C12 C13 C14 C15 C16}  {
            :modify .$i :value 0

         }

        set pos [exec rsh eb56 $TARGETPATH/bin/target]
        puts stdout "target position returned by status: $pos"
        set z [catch {exec rsh eb56 $TARGETPATH/bin/status} state]
        if {$z != 0} then {
                midas-warning "Error: command status failed"\
                puts stdout "command status returned value: $state"
                return
        }
        switch $pos {
           1  {:modify .C11 :value 1}
           2  {:modify .C12 :value 1}
           3  {:modify .C13 :value 1}
           4  {:modify .C14 :value 1}
           5  {:modify .C15 :value 1}
           6  {:modify .C16 :value 1}
           default  {midas-warning "Can't connect to euroball target !\n"}
         }
       set-footer "Current target position : $pos"
    return

}

proc click arg {
   global debug 
   global i
   if {$debug} then {insert-debug "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch $w  {
	GETSTATUS  {click-get}
	SETTARGET  {click-set $i}
	REDISPLAY  {click-redisplay}
	CLEARFIELDS {click-clear}
	DELETESAVEFILE {click-delete}
      C11        {set i 1
                  :modify .C12 :value 0
                  :modify .C13 :value 0
                  :modify .C14 :value 0
                  :modify .C15 :value 0
                  :modify .C16 :value 0
                  }
      C12        {set i 2
                  :modify .C11 :value 0
                  :modify .C13 :value 0
                  :modify .C14 :value 0
                  :modify .C15 :value 0
                  :modify .C16 :value 0
                  }
      C13        {set i 3
                  :modify .C11 :value 0
                  :modify .C12 :value 0
                  :modify .C14 :value 0
                  :modify .C15 :value 0
                  :modify .C16 :value 0
                  }
      C14        {set i 4
                  :modify .C11 :value 0
                  :modify .C12 :value 0
                  :modify .C13 :value 0
                  :modify .C15 :value 0
                  :modify .C16 :value 0
                  }
      C15        {set i 5
                  :modify .C11 :value 0
                  :modify .C12 :value 0
                  :modify .C13 :value 0
                  :modify .C14 :value 0
                  :modify .C16 :value 0
                  }
      C16        {set i 6
                  :modify .C11 :value 0
                  :modify .C12 :value 0
                  :modify .C13 :value 0
                  :modify .C14 :value 0
                  :modify .C15 :value 0
                  }
      default   {puts stdout "ex: unexpected click with argument \{$arg\}"}

   }
}


proc start args {
   global started
   if {$started == 0} then {
     make-frame
     set started 1
    } else {open-frame}
}


proc click-comment {i text} {
global directory commentfile LOGFILEPATH
   set directory $LOGFILEPATH
   set comment comments
   set commentfile $directory/$comment
   set z [catch {open $commentfile a} file]
    if {$z != 0} then {midas-warning "Unable to Save file $commentfile"; return}
	puts $file "$i $text\n"
	insert-log "comment for target $i is :$text\n"
   close $file

}
   
proc read-comment w  {
 global i text pattern field 
 set z [catch {open $w "r"} f]
 	if {$z != 0} then {
		midas-warning "Can't open specified file!!!!\n"
		flush $f
		foreach i {1 2 3 4 5 6} {
        		:modify .POSITION$i :value ""
      		}
		clear-footer
		return
	} else {
		while {[gets $f line] >= 0}  {
			foreach i {1 2 3 4 5 6} {
				set pattern($i) POSITION$i	
					if [regexp $pattern($i) $line$i] {
						set field($i) [string range $line 10 end]
						:modify .POSITION$i :value "$field($i)"
						insert-log "redisplaying target contents...: $field($i)\n"
					}
			
			}
		}
	}	
	close $f
	
}


proc click-delete {}  {
   global directory commentfile LOGFILEPATH

   set file commentfile
   set-footer "deleting save $file..."
	if {![midas-confirmation "Do you really wish to delete the\
	comments file?"]} then {
	clear-footer
	return
	}
   set z [catch {:file delete $LOGFILEPATH/comments} m]
	if {$z != 0} then {midas-warning "$m"
      			 return
	}
	set-footer "$file erased!!"
}

proc click-redisplay {} {
   global directory commentfile field LOGFILEPATH
   clear-footer
   read-comment $LOGFILEPATH/comments
      clear-footer
      foreach i {1 2 3 4 5 6} {
        :modify .POSITION$i :value "$field($i)"
      }
}



proc click-clear {} {
	global field 
		clear-footer
		foreach i {1 2 3 4 5 6} {
        		:modify .POSITION$i :value ""
      	} 
	set-footer "OK! Fields cleared!"
}


proc click-Save {lines} {
   
   global  directory commentfile

   set target commentfile
   set c 0

   set z [catch {open $target w} file]
   if {$z != 0} then {set-footer $file; return}
    puts $file [join $lines "\n"]   
    
             set s $directory/$target
             set footer "saving $s..."
   set z [catch {:file copy -force $s $directory} m]            
   if {$z != 0 || $m != ""} then {set-footer $m; return}        
   click-redisplay
   if {$z!=0} then {set-footer "$m"} else {set-footer "comment file $commentfile  saved"}

}

